;    list p=12f683,b=4,n=0   ; declare processor, tabs, and lines/page

;**********************************************************************
;   Copyright (C) 2005,2006,2007,2008 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************
;
;   This is a merger of a number of Blinkie programs I created for different
;   www.2DKits.com boards. The current goal of this code is to support all
;   the 12F683 based boards, and then eventually adding of the 16F688 boards.
;
;   4RBG /w common anode (ufo and clear 5mm) .... Working
;   4RBG /w common Cathode (milk 5mm) ........... Working
;   6 BI /w bi-color LEDs. ...................... Working
;                                                 - update all for new mult patterns in eeprom logic.
;   6 BI /w mono LEDs. .......................... Working
;                                                 - want to add brightness patterns
;                                                 - update all for new mult patterns in eeprom logic.
;   badge 6 bi-color plus 1 mono, no IR ......... Working
;                                                 - update all for new mult patterns in eeprom logic.
;   badge 7 LED /w mono LEDs, no IR ............. Working
;                                                 - update all for new mult patterns in eeprom logic.
;   19 LED Stick ................................ Working
;   19 circle /w mono............................ Working
;                                                 - draft
;   19 circle /w bi-color........................ Working
;                                                 - Draft
;   RGB Stick ................................... Draft
;   3x3 /w mono ................................. Need
;   3x3 /w bi-color ............................. Draft
;   16x8x2 ...................................... Working on
;   
;   Dwayne Forsyth wrote the original code, Dwayne pulled a number of updates,
;   code cleanup, and patterns from Dave Holle.
;                                                                     
;**********************************************************************
;                                                                     
;    Filename:      generic_683.asm                                         
;    Date:          04/05/2007                                 
;                                                         
;    Author:  Dwayne Forsyth
;    email:   Dwayne@2DKits.com                                         
;    Company: www.2DKits.com
;             502 Rue Orleanais
;             Deer Park, IL 60010    
;
;    Help from: Dave Holle <dav@serve-o-matic.com>                        
;                                                                      
;**********************************************************************

    errorlevel  -302                ; suppress banking messages
#ifdef __16F726
    __CONFIG    _CONFIG1, _CP_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF 
#else
#ifdef __16F886
    __CONFIG    _CONFIG1, _DEBUG_OFF & _LVP_OFF & _FCMEN_ON & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF  & _INTOSCIO
    __CONFIG    _CONFIG2, _WRT_OFF & _BOR21V
#else
    __CONFIG _CP_OFF & _CPD_OFF & _BOD_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _FCMEN_OFF & _IESO_OFF
#endif
#endif

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The labels following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.

; this SIM_DEBUG disables the buttons and IR inputs so the code will run the patterns.
; #define SIM_DEBUG

;----------------------------------------------------
; Select 1 board config!
;----------------------------------------------------
;#define RGB4
;#define RGB4_Common_Cathode
;#define BI6
;#define BI6_MONO
;#define BI6_BADGE
;#define BI6_BADGE_MONO
;#define S19
;#define C19
;#define C19_MONO
;#define M3X3
;#define M3X3_MONO
;#define SRGB
;#define SRGB_Common_Cathode
#define M8X16               ; Rom "J"
;#define C12                 ; Rom "M"
;#define C12_MONO            ; Rom "L"
;#define C12_SINGLE          ; Rom "K"
;#define C12_SINGLE_MONO     ; Rom "P"
;----------------------------------------------------

;*********************************
; 4RBG /w common anode (ufo and clear 5mm)
;*********************************

#ifdef RGB4
#define PATTERN1
#define PATTERN2
#define PATTERN3
#define PATTERN4
#define PATTERN20
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#define ENABLE_IR
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; 4RBG /w common Cathode (milk 5mm and 10mm)
;*********************************

#ifdef RGB4_Common_Cathode
#define RGB4
#define Common_Cathode
#define PATTERN1
#define PATTERN2
#define PATTERN3
#define PATTERN4
#define PATTERN20
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#define ENABLE_IR
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
 NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; 6 BI /w bi-color LEDs.
;*********************************

#ifdef BI6
#define BIN2LED
#define PATTERN1
#define PATTERN3
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#define ENABLE_IR
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
 NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; 6 BI /w mono LEDs.
;*********************************

#ifdef BI6_MONO
#define BI6
#define MONO
#define FLIPBYTE
#define PATTERN5
#define PATTERN11
#define DISPLAY_1BIT_A
#define DISPLAY_2BIT_A
#define ENABLE_IR
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'17'   ;highest pattern table number
#endif

;*********************************
; badge 6 bi-color plus 1 mono LEDs.
;*********************************

#ifdef BI6_BADGE
#define BI6
#define BIN2LED
#define PATTERN10
#define PATTERN3
#define BADGE
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; badge 6 mono LEDs.
;*********************************

#ifdef BI6_BADGE_MONO
#define BI6
#define MONO
#define BADGE
#define PATTERN5
#define PATTERN11
#define FLIPBYTE
#define DISPLAY_1BIT_A
#define DISPLAY_2BIT_A
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'19'   ;highest pattern table number
#endif

;#define DREW  ; special pattern in EEProm for Drew

;*********************************
; 19 LED Stick
;*********************************

#ifdef S19
#define PATTERN6
#define PATTERN7
#define PATTERN8
#define FLIPBYTE
#define DISPLAY_1BIT_D
#define ENABLE_IR
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'23'   ;highest pattern table number
#endif

;*********************************
; 19 Circle bicolor 
;*********************************

#ifdef C19
#define PATTERN9
#define PATTERN12
#define PATTERN13
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DISPLAY_1BIT_B
#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F688.inc>       ; processor specific variable definitions
 LIST P=PIC16F688
NUM_TAB     equ d'25'   ;highest pattern table number
#endif

;*********************************
; 19 Circle mono
;*********************************

#ifdef C19_MONO
#define MONO
#define C19
#define PATTERN9
#define PATTERN12
#define PATTERN14
#define RANDOM
#define BIN2LED
#define DEDICATED_BUTTON
#define DISPLAY_1BIT_B
#define DISPLAY_2BIT_E
#define ENABLE_IR
#include	<P16F688.inc>       ; processor specific variable definitions
 LIST P=PIC16F688
NUM_TAB     equ d'25'   ;highest pattern table number
#endif

;*********************************
; 3x3 matrix Bi-color
;*********************************

#ifdef M3X3
#define PATTERN6
#define PATTERN19
#define PATTERN21
#define BIN2LED
#define DISPLAY_1BIT_F
#define ENABLE_IR
#define MULTIBUTTON
#define RANDOM
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; 3x3 matrix mono
;*********************************

#ifdef M3X3_MONO
#define M3X3
#define MONO
#define PATTERN6
#define PATTERN19
#define PATTERN21
#define BIN2LED
#define DISPLAY_1BIT_F
#define ENABLE_IR
#define MULTIBUTTON
#define RANDOM
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; RGB Stick (new UFO
;*********************************

#ifdef SRGB
#define PATTERN15
#define PATTERN16
#define PATTERN17
#define PATTERN18
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_E
#define ENABLE_IR
#include	<P16F688.inc>       ; processor specific variable definitions
 LIST P=PIC16F688
NUM_TAB     equ d'15'   ;highest pattern table number
#endif

;*********************************
; RGB Stick
;*********************************

#ifdef SRGB_Common_Cathode
#define SRGB
#define Common_Cathode
#define PATTERN15
#define PATTERN16
#define PATTERN17
#define PATTERN18
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_E
#define ENABLE_IR
#include	<P16F688.inc>       ; processor specific variable definitions
 LIST P=PIC16F688
NUM_TAB     equ d'15'   ;highest pattern table number
#endif

;*********************************
; 8x16 Matrix 
;*********************************

#ifdef M8X16
#define PATTERN12
#define PATTERN22
#define PATTERN24
#define PATTERN25
#define PATTERN26
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DISPLAY_1BIT_G
;#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F886.inc>       ; processor specific variable definitions
 LIST P=PIC16F886
NUM_TAB     equ d'18'   ;highest pattern table number
#endif

;*********************************
; 12 Double Bi-color Circle 
;*********************************

#ifdef C12
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F886.inc>       ; processor specific variable definitions
 LIST P=PIC16F886
NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; 16 Double Mono Circle 
;*********************************

#ifdef C12_MONO
#define C12
#define MONO
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F886.inc>       ; processor specific variable definitions
 LIST P=PIC16F886
NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; 12 Single Bi-color Circle 
;*********************************

#ifdef C12_SINGLE
#define C12
#define SINGLE
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F886.inc>       ; processor specific variable definitions
 LIST P=PIC16F886
NUM_TAB     equ d'14'   ;highest pattern table number
#endif

;*********************************
; 16 Single Mono Circle 
;*********************************

#ifdef C12_SINGLE_MONO
#define C12
#define SINGLE
#define MONO
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F886.inc>       ; processor specific variable definitions
 LIST P=PIC16F886
NUM_TAB     equ d'14'   ;highest pattern table number
#endif


;**********************************************************************
; Macros
;**********************************************************************
; bank select macros
setbank0 macro
    bcf STATUS,RP0  ; select bank 0
    bcf STATUS,RP1
    endm

setbank1 macro
    bsf STATUS,RP0  ; select bank 1
    bcf STATUS,RP1
    endm

mem = 20
mem2 = 0x7F
mem3 = 0xa0

var macro name
name equ  mem
mem = mem + 1
   if (mem >= mem2)
      error 'Too much var space used'
   endif
   endm

dupvar macro name, name2
name equ name2
   endm

var_all_bank macro name
name equ  mem2
mem2 = mem2 - 1
   if (mem >= mem2)
      error 'Too much var space used'
   endm

mem3 = 0xa0
var_bank2 macro name
name equ  mem3
mem3 = mem3 + 1
   if (mem3 >= 0xef)
      error 'Too much var space used'
   endm

patternc = 0
start_pattern macro typem, delaym

table#v(patternc)
    if (typem == 1) || (typem == 6) || (typem == 0x15)
leng = (endpat#v(patternc)-$-3)/3   ;tbltype1,speed,length
    else
    if (typem == 3) || (typem == 0x0b) || (typem == 0x10) || (typem == 0x13) || (typem == 0x14)|| (typem == 0x18)
leng = (endpat#v(patternc)-$-3)/2   ;tbltype1,speed,length
    else
    if (typem == 9) || (typem == 0x0e)
leng =(endpat#v(patternc)-$-3)/5   ;tbltype1,speed,length
    else
    if (typem == 0x0a)
leng =(endpat#v(patternc)-$-3)/4   ;tbltype1,speed,length
    else
    if (typem == 0x0d)
leng =(endpat#v(patternc)-$-3)/(9+1)   ;tbltype1,speed,length
    else
    if (typem == 0x0f) || (typem == 0x12)|| (typem == 0x17)||(typem == 0x1b)
leng =(endpat#v(patternc)-$-3)/(6)   ;tbltype1,speed,length
    else
    if (typem == 0x11)
leng = (endpat#v(patternc)-$-3)/(9+4)   ;tbltype1,speed,length
    else
    if (typem == 0x16) || (typem == 0x1a)
leng = (endpat#v(patternc)-$-3)/0x20   ;tbltype1,speed,length
    else    
leng =(endpat#v(patternc)-$-3)
    endif
    endif
    endif
    endif
    endif
    endif
    endif
    endif
    expand
    if ($ < 0x2100)
    dt typem,delaym,(leng)
    else
    de typem,delaym,(leng)
    endif
   endm

storedata macro stuff
    if ($ < 0x2100)
    dt stuff
    else
    de stuff
    endif
   endm

end_pattern macro
endpat#v(patternc)
patternc = patternc + 1
   endm

mult_nop macro nup_count
  local i = nup_count
  while i > 3
    call    Lcontinue   ;4 cycles
i -= 4
  endw
  while i > 1
    goto    $+1         ;2 cycles
i -= 2
  endw
  if i > 0
    nop                 ;1 cycle
  endif
    endm

LedOut macro word,reg_dir,port
    movfw   TMR0
	subwf   word,w
	btfss   STATUS,C    
    bsf     reg_dir, port
   endm

LedOutInd macro word,reg_dir,port
    movlw   word
    movwf   FSR         ; set indirect pointer to word
    movfw   TMR0
	subwf   INDF,w      
	btfss   STATUS,C    
    bsf     reg_dir, port
   endm

; Indirect Paged
LedOutIndP macro page,word,reg_dir,port
    if (page == 0)
      bcf   STATUS,IRP
    else
      bsf   STATUS,IRP
    endif
    movlw   (word & 0xff)
    movwf   FSR         ; set indirect pointer to word
    movfw   TMR0
	subwf   INDF,w      
	btfss   STATUS,C    
    bsf     reg_dir, port
   endm

LedOutL macro word,reg_dir,port
    swapf   word,w
    movwf   temp4
    movfw   TMR0
	subwf   temp4,w
	btfss   STATUS,C    
    bsf     reg_dir, port
   endm

LedOutH macro word,reg_dir,port
    nop
    nop
    movfw   TMR0
	subwf   word,w
	btfss   STATUS,C    
    bsf     reg_dir, port
   endm

state_tbl macro num,zero,one,flag
Lstate#v(num)
#ifndef MULTIBUTTON
    if (flag == 0)
       bcf  button,0                         
       movlw  0x30
       movwf  butcount
    endif 
    if (flag == 1)
       bsf  button,0
    endif
#endif
    btfsc        IR_in,0
    goto         Lstate#v(num)a

    movlw        zero
    movwf        instate

    goto         Lcontinue
      
Lstate#v(num)a
    movlw        one
    movwf        instate

    goto         Lcontinue    
    endm

state2_tbl macro num, name, offset
Lstate#v(num)
;   save the 1st half of word
    movf         IR_in,w    ; save 1st half
    movwf        IR_lhalf
    incf         instate,f

    goto         Lcontinue
      
Lstate#v(num+1)
;   save the 2nd half of word
;   check for protocal error should get 01 or 10
    movf         IR_lhalf,w
    xorwf        IR_in,w
    btfss        STATUS,Z
    goto         Lstate#v(num+1)a
    clrf         instate    ; error state = zero
 
    goto         Lcontinue

;   set the correct bit in output vars.
Lstate#v(num+1)a
    btfsc        IR_in,0
    bcf          name,offset
    btfss        IR_in,0
    bsf          name,offset

    incf         instate,f    
    goto         Lcontinue
    endm

entry macro a0,a1,a2
    dt      a0,a1,a2
    endm

tbltype1 macro speed,length
  if (length > 2) & (length < d'256')
    dt      0x01,speed,length
  else
    error   'pattern length must be > 2 and < 256'
  endif
    endm

make_mtab macro numtab
  local i = 0
  while i <= numtab
    dt      HIGH table#v(i), LOW table#v(i) 
i += 1
  endw
  endm

make_state_jump_table macro max_state
  local i = 0
  while i <= max_state
    dt      HIGH Lstate#v(i), LOW Lstate#v(i) 
i += 1
  endw
  endm


#ifdef __12F683
PORTA       EQU GPIO
TRISA       EQU TRISIO
NOT_RAPU    EQU NOT_GPPU
#endif

;             ++-------- A7 A6  unimplemented (0)
;             || +------ A4     IR LED output (0)
;             || |+----- A3     detector/button input (1)
;             || ||
;           b'00101111'     ;set LED matrix pins to input (tri-stated)
;               |  ||| 
;               +--+++-- LED matrix on A5 A2 A1 A0 (1)

;**********************************************************************
    ORG     0x000           ; processor reset vector
;**********************************************************************
    goto        main            ; go to beginning of program

;**********************************************************************
    ORG     0x004           ; interrupt vector location
;**********************************************************************
    var_all_bank w_temp          ; variable used for context saving
    var_all_bank status_temp     ; variable used for context saving

#ifdef __16F688
    var_all_bank fsr_save
    var_all_bank pclath_temp
#endif

#ifdef __16F726
    var_all_bank fsr_save
    var_all_bank pclath_temp
#endif

#ifdef __16F886
    var_all_bank fsr_save
    var_all_bank pclath_temp
#endif


    var nextf                    ; flags for timing loops
;                                  bit 0 is one display cycle (890 usec)
;                                  bit 1 is about 1 minute
    var dcycle                   ; stobe counter [0-3]
    var count1                   ; lower bit counter
    var count2                   ; higher bit counter.

#ifdef __12F683
    movwf       w_temp          ; copy W to TEMP register
    swapf       STATUS,w        ; Swap status to be saved into W
    clrf        STATUS          ; Bank 0
    movwf       status_temp     ; save off contents of PCLATH register
#else
	movwf		w_temp			; save off current W register contents
	movf		STATUS,w		; move status register into W register
	movwf		status_temp		; save off contents of STATUS register
	movf		PCLATH,w		; move pclath register into W register
	movwf		pclath_temp		; save off contents of PCLATH register
    movf        FSR,w
    movwf       fsr_save
#endif

here
    setbank0
    pageselw here
;
;   set tick interupt to 889ms for IR RC5 protocal 1/2 digit.
;   an Interupt every 889us /w 8mhz internal osc
;

#define  TICK_VALUE   D'35'

    movlw       TICK_VALUE
    movwf       TMR0                       
;
;   increment the stobe and duration counters
;

    incf     dcycle,f

#ifdef RGB4
    movlw    0x04
#else
#ifdef BI6
    movlw    0x04
#else
#ifdef S19
    movlw    0x05
#else
#ifdef C19
    movlw    0x07
#else
#ifdef M3X3
    movlw    0x05
#else
#ifdef SRGB
    movlw    0x07
#else
#ifdef M8X16
    movlw    0x10
#else
#ifdef C12
    movlw    0x06
#else
    error "unknown board strobe type"
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif

    subwf    dcycle,w
    btfsc    STATUS,C
    clrf     dcycle

    bsf      nextf,0

    incfsz      count1,f
    goto        skip1

    incfsz      count2,f
    goto        skip1

    bsf         nextf,1

skip1

    movf        scount,w                    ; F22
    addlw       0                           ; F23
    btfsc       STATUS,Z                    ; F24
    goto        send_nothing                ; F25

    btfss       tx_1,0                      ; F26
    goto        send_zero                   ; F27

;--------------------------------------------------------------------------------------
send_one  ; we are slaming the 36K IR siginal, its like a busy wait!
;--------------------------------------------------------------------------------------
    var repeat
#ifdef S19
    setbank1
    movlw   b'00011010'      ;set A0 & A5 led to output
    movwf   TRISA
    setbank0
#define IRBIT 0
#define IRPORT PORTA
#else
#ifdef C12
    setbank1
    movlw   b'11011011'      ;set B2 & B5 led to output
    movwf   TRISB
    setbank0
#define IRBIT 2              
#define IRPORT PORTB
#else
#ifdef M8X16
#define IRBIT 1              
#define IRPORT PORTC
#else
#ifdef M3X3
    setbank1
    movlw   b'00111001'      ;set A1 & A2 led to output
    movwf   TRISA
    setbank0
#define IRBIT 1
#define IRPORT PORTA
#else
#ifdef SRGB
#define IRBIT 1
#define IRPORT PORTA
#else
#define IRBIT 4
#define IRPORT PORTA
#endif
#endif
#endif
#endif
#endif

    clrf        IRPORT
    bsf         IRPORT,IRBIT                     ; A01

    call        get_next_tx_bit             ; 2 + 11 cycles  A04-A16
;    mult_nop d'9' ; A17-A25
    movlw       01h
    call        qdelay           ; 6 + (1 * 3) = 9 ; A17-A25
    nop

    movlw           0x1E                    ; C26  (23)
    movwf           repeat                  ; C27
repeat_loop
    bcf         IRPORT,IRBIT                         ; D01

;    mult_nop d'26' ; D02-D27
    movlw       07h
    call        qdelay           ; 6 + (7 * 3) = 27 ; D02-D27

    bsf         IRPORT,IRBIT                         ; E01  (27)

;    mult_nop d'23' ; E02-E24
    movlw       06h              ; 6+(6 * 3) = 22 ; E02-E24
    call qdelay

    decfsz      repeat,f                    ; E25      (24)
    goto        repeat_loop                    ; E26/E27

    bcf         IRPORT,IRBIT
    goto        exit_tx

;--------------------------------------------------------------------------------------
send_zero  ; we are going to release all the CPU time to the main line for display.
;--------------------------------------------------------------------------------------

    call        get_next_tx_bit             ; 2 + 11 cycles  A04-A16
    goto        drive_main_leds

;--------------------------------------------------------------------------------------
send_nothing ; Drive the main LEDs.
;--------------------------------------------------------------------------------------

    call        read_ir_in
#ifdef DEDICATED_BUTTON
    call        read_button_in
#endif
;   goto        drive_main_leds   

;--------------------------------------------------------------------------------------
drive_main_leds ; Drive the main LEDs.
;--------------------------------------------------------------------------------------
	var fcount
#ifndef S19
#ifndef C19
#ifndef SRGB
#ifndef M3X3
#ifndef M8X16
#ifndef C12
	var Ar_reg
	var Ag_reg
	var Ab_reg
	var Br_reg
	var Bg_reg
	var Bb_reg
	var Cr_reg
	var Cg_reg
	var Cb_reg
	var Dr_reg
	var Dg_reg
	var Db_reg
#endif
#endif
#endif
#endif
#endif
#endif

#ifdef BADGE
    var Center_reg
#endif
#ifdef M3X3
    var A0_A1_reg
    var A0_A2_reg
    var A0_A4_reg
    var A0_A5_reg
    var A1_A0_reg
    var A1_A2_reg
    var A1_A4_reg
    var A1_A5_reg
    var A2_A0_reg
    var A2_A1_reg
    var A2_A4_reg
    var A2_A5_reg
    var A4_A0_reg
    var A4_A1_reg
    var A4_A2_reg
    var A4_A5_reg
    var A5_A0_reg
    var A5_A1_reg
    var A5_A2_reg
    var A5_A4_reg
#endif
#ifdef S19
    var A0_A1_reg
    var A0_A2_reg
    var A0_A4_reg
    var A0_A5_reg
    var A1_A0_reg
    var A1_A2_reg
    var A1_A4_reg
    var A1_A5_reg
    var A2_A0_reg
    var A2_A1_reg
    var A2_A4_reg
    var A2_A5_reg
    var A4_A0_reg
    var A4_A1_reg
    var A4_A2_reg
    var A4_A5_reg
    var A5_A0_reg
    var A5_A1_reg
    var A5_A2_reg
    var A5_A4_reg
#endif
#ifdef C19
    var_bank2 A0_A1_reg
    var_bank2 A0_A2_reg
    var_bank2 A0_C0_reg
    var_bank2 A0_C1_reg
    var_bank2 A0_C2_reg
    var_bank2 A0_C4_reg

    var_bank2 A1_A0_reg
    var_bank2 A1_A2_reg
    var_bank2 A1_C0_reg
    var_bank2 A1_C1_reg
    var_bank2 A1_C2_reg
    var_bank2 A1_C4_reg

    var_bank2 A2_A0_reg
    var_bank2 A2_A1_reg
    var_bank2 A2_C0_reg
    var_bank2 A2_C1_reg
    var_bank2 A2_C2_reg
    var_bank2 A2_C4_reg

    var_bank2 C0_A0_reg
    var_bank2 C0_A1_reg
    var_bank2 C0_A2_reg
    var_bank2 C0_C1_reg
    var_bank2 C0_C2_reg
    var_bank2 C0_C4_reg

    var_bank2 C1_A0_reg
    var_bank2 C1_A1_reg
    var_bank2 C1_A2_reg
    var_bank2 C1_C0_reg
    var_bank2 C1_C2_reg
    var_bank2 C1_C4_reg

    var_bank2 C2_A0_reg
    var_bank2 C2_A1_reg
    var_bank2 C2_A2_reg
    var_bank2 C2_C0_reg
    var_bank2 C2_C1_reg
    var_bank2 C2_C4_reg

    var_bank2 C4_A0_reg
    var_bank2 C4_A1_reg
    var_bank2 C4_A2_reg
    var_bank2 C4_C0_reg
    var_bank2 C4_C1_reg
    var_bank2 C4_C2_reg
#endif
#ifdef SRGB
;
;   The shifter pattern needs the colored LEDs defined sequentially
;
    var_bank2 C5_C3_reg ; 01 R
    var_bank2 C2_C3_reg ; 02 R
    var_bank2 C0_C4_reg ; 03 R
    var_bank2 C5_C4_reg ; 04 R
    var_bank2 C3_C5_reg ; 05 R
    var_bank2 C4_C5_reg ; 06 R
    var_bank2 A2_C0_reg ; 07 R
    var_bank2 C3_C0_reg ; 08 R
    var_bank2 C0_A2_reg ; 09 R
    var_bank2 C3_A2_reg ; 10 R
    var_bank2 A2_C2_reg ; 11 R
    var_bank2 C3_C2_reg ; 12 R
    var_bank2 A2_C1_reg ; 13 R
    var_bank2 C3_C1_reg ; 14 R

    var_bank2 A2_C3_reg ; 01 G
    var_bank2 C0_C3_reg ; 02 G
    var_bank2 A2_C4_reg ; 03 G
    var_bank2 C3_C4_reg ; 04 G
    var_bank2 C0_C5_reg ; 05 G
    var_bank2 A2_C5_reg ; 06 G
    var_bank2 C4_C0_reg ; 07 G
    var_bank2 C5_C0_reg ; 08 G
    var_bank2 C4_A2_reg ; 09 G
    var_bank2 C5_A2_reg ; 10 G 
    var_bank2 C4_C2_reg ; 11 G
    var_bank2 C5_C2_reg ; 12 G
    var_bank2 C4_C1_reg ; 13 G
    var_bank2 C5_C1_reg ; 14 G

    var_bank2 C1_C3_reg ; 01 B ?
    var_bank2 C4_C3_reg
    var_bank2 C2_C4_reg ; 03 B
    var_bank2 C1_C4_reg ; 04 B
    var_bank2 C1_C5_reg ; 05 B
    var_bank2 C2_C5_reg ; 06 B
    var_bank2 C2_C0_reg ; 07 B
    var_bank2 C1_C0_reg ; 08 B
    var_bank2 C2_A2_reg ; 09 B
    var_bank2 C1_A2_reg ; 10 B
    var_bank2 C1_C2_reg ; 11 B
    var_bank2 C0_C2_reg
    var_bank2 C2_C1_reg ; 13 B ?
    var_bank2 C0_C1_reg ; 14 B

#endif

#ifdef M8X16

; Bank 1
Led_G00  equ 0x0b0
Led_G01  equ 0x0b1
Led_G02  equ 0x0b2
Led_G03  equ 0x0b3
Led_G04  equ 0x0b4
Led_G05  equ 0x0b5
Led_G06  equ 0x0b6
Led_G07  equ 0x0b7

Led_G10  equ 0x0b8
Led_G11  equ 0x0b9
Led_G12  equ 0x0ba
Led_G13  equ 0x0bb
Led_G14  equ 0x0bc
Led_G15  equ 0x0bd
Led_G16  equ 0x0be
Led_G17  equ 0x0bf

Led_G20  equ 0x0c0
Led_G21  equ 0x0c1
Led_G22  equ 0x0c2
Led_G23  equ 0x0c3
Led_G24  equ 0x0c4
Led_G25  equ 0x0c5
Led_G26  equ 0x0c6
Led_G27  equ 0x0c7

Led_G30  equ 0x0c8
Led_G31  equ 0x0c9
Led_G32  equ 0x0ca
Led_G33  equ 0x0cb
Led_G34  equ 0x0cc
Led_G35  equ 0x0cd
Led_G36  equ 0x0ce
Led_G37  equ 0x0cf

; Bank 2
Led_G40  equ 0x110
Led_G41  equ 0x111
Led_G42  equ 0x112
Led_G43  equ 0x113
Led_G44  equ 0x114
Led_G45  equ 0x115
Led_G46  equ 0x116
Led_G47  equ 0x117

Led_G50  equ 0x118
Led_G51  equ 0x119
Led_G52  equ 0x11a
Led_G53  equ 0x11b
Led_G54  equ 0x11c
Led_G55  equ 0x11d
Led_G56  equ 0x11e
Led_G57  equ 0x11f

Led_G60  equ 0x120
Led_G61  equ 0x121
Led_G62  equ 0x122
Led_G63  equ 0x123
Led_G64  equ 0x124
Led_G65  equ 0x125
Led_G66  equ 0x126
Led_G67  equ 0x127

Led_G70  equ 0x128
Led_G71  equ 0x129
Led_G72  equ 0x12a
Led_G73  equ 0x12b
Led_G74  equ 0x12c
Led_G75  equ 0x12d
Led_G76  equ 0x12e
Led_G77  equ 0x12f

Led_G80  equ 0x130
Led_G81  equ 0x131
Led_G82  equ 0x132
Led_G83  equ 0x133
Led_G84  equ 0x134
Led_G85  equ 0x135
Led_G86  equ 0x136
Led_G87  equ 0x137

Led_G90  equ 0x138
Led_G91  equ 0x139
Led_G92  equ 0x13a
Led_G93  equ 0x13b
Led_G94  equ 0x13c
Led_G95  equ 0x13d
Led_G96  equ 0x13e
Led_G97  equ 0x13f

Led_GA0  equ 0x140
Led_GA1  equ 0x141
Led_GA2  equ 0x142
Led_GA3  equ 0x143
Led_GA4  equ 0x144
Led_GA5  equ 0x145
Led_GA6  equ 0x146
Led_GA7  equ 0x147

Led_GB0  equ 0x148
Led_GB1  equ 0x149
Led_GB2  equ 0x14a
Led_GB3  equ 0x14b
Led_GB4  equ 0x14c
Led_GB5  equ 0x14d
Led_GB6  equ 0x14e
Led_GB7  equ 0x14f

Led_GC0  equ 0x150
Led_GC1  equ 0x151
Led_GC2  equ 0x152
Led_GC3  equ 0x153
Led_GC4  equ 0x154
Led_GC5  equ 0x155
Led_GC6  equ 0x156
Led_GC7  equ 0x157

Led_GD0  equ 0x158
Led_GD1  equ 0x159
Led_GD2  equ 0x15a
Led_GD3  equ 0x15b
Led_GD4  equ 0x15c
Led_GD5  equ 0x15d
Led_GD6  equ 0x15e
Led_GD7  equ 0x15f

Led_GE0  equ 0x160
Led_GE1  equ 0x161
Led_GE2  equ 0x162
Led_GE3  equ 0x163
Led_GE4  equ 0x164
Led_GE5  equ 0x165
Led_GE6  equ 0x166
Led_GE7  equ 0x167

Led_GF0  equ 0x168
Led_GF1  equ 0x169
Led_GF2  equ 0x16a
Led_GF3  equ 0x16b
Led_GF4  equ 0x16c
Led_GF5  equ 0x16d
Led_GF6  equ 0x16e
Led_GF7  equ 0x16f

; Bank 1
Led_R00  equ 0x0d0
Led_R01  equ 0x0d1
Led_R02  equ 0x0d2
Led_R03  equ 0x0d3
Led_R04  equ 0x0d4
Led_R05  equ 0x0d5
Led_R06  equ 0x0d6
Led_R07  equ 0x0d7

Led_R10  equ 0x0d8
Led_R11  equ 0x0d9
Led_R12  equ 0x0da
Led_R13  equ 0x0db
Led_R14  equ 0x0dc
Led_R15  equ 0x0dd
Led_R16  equ 0x0de
Led_R17  equ 0x0df

Led_R20  equ 0x0e0
Led_R21  equ 0x0e1
Led_R22  equ 0x0e2
Led_R23  equ 0x0e3
Led_R24  equ 0x0e4
Led_R25  equ 0x0e5
Led_R26  equ 0x0e6
Led_R27  equ 0x0e7

Led_R30  equ 0x0e8
Led_R31  equ 0x0e9
Led_R32  equ 0x0ea
Led_R33  equ 0x0eb
Led_R34  equ 0x0ec
Led_R35  equ 0x0ed
Led_R36  equ 0x0ee
Led_R37  equ 0x0ef

; bank 3
Led_R40  equ 0x190
Led_R41  equ 0x191
Led_R42  equ 0x192
Led_R43  equ 0x193
Led_R44  equ 0x194
Led_R45  equ 0x195
Led_R46  equ 0x196
Led_R47  equ 0x197

Led_R50  equ 0x198
Led_R51  equ 0x199
Led_R52  equ 0x19a
Led_R53  equ 0x19b
Led_R54  equ 0x19c
Led_R55  equ 0x19d
Led_R56  equ 0x19e
Led_R57  equ 0x19f

Led_R60  equ 0x1a0
Led_R61  equ 0x1a1
Led_R62  equ 0x1a2
Led_R63  equ 0x1a3
Led_R64  equ 0x1a4
Led_R65  equ 0x1a5
Led_R66  equ 0x1a6
Led_R67  equ 0x1a7

Led_R70  equ 0x1a8
Led_R71  equ 0x1a9
Led_R72  equ 0x1aa
Led_R73  equ 0x1ab
Led_R74  equ 0x1ac
Led_R75  equ 0x1ad
Led_R76  equ 0x1ae
Led_R77  equ 0x1af

Led_R80  equ 0x1b0
Led_R81  equ 0x1b1
Led_R82  equ 0x1b2
Led_R83  equ 0x1b3
Led_R84  equ 0x1b4
Led_R85  equ 0x1b5
Led_R86  equ 0x1b6
Led_R87  equ 0x1b7

Led_R90  equ 0x1b8
Led_R91  equ 0x1b9
Led_R92  equ 0x1ba
Led_R93  equ 0x1bb
Led_R94  equ 0x1bc
Led_R95  equ 0x1bd
Led_R96  equ 0x1be
Led_R97  equ 0x1bf

Led_RA0  equ 0x1c0
Led_RA1  equ 0x1c1
Led_RA2  equ 0x1c2
Led_RA3  equ 0x1c3
Led_RA4  equ 0x1c4
Led_RA5  equ 0x1c5
Led_RA6  equ 0x1c6
Led_RA7  equ 0x1c7

Led_RB0  equ 0x1c8
Led_RB1  equ 0x1c9
Led_RB2  equ 0x1ca
Led_RB3  equ 0x1cb
Led_RB4  equ 0x1cc
Led_RB5  equ 0x1cd
Led_RB6  equ 0x1ce
Led_RB7  equ 0x1cf

Led_RC0  equ 0x1d0
Led_RC1  equ 0x1d1
Led_RC2  equ 0x1d2
Led_RC3  equ 0x1d3
Led_RC4  equ 0x1d4
Led_RC5  equ 0x1d5
Led_RC6  equ 0x1d6
Led_RC7  equ 0x1d7

Led_RD0  equ 0x1d8
Led_RD1  equ 0x1d9
Led_RD2  equ 0x1da
Led_RD3  equ 0x1db
Led_RD4  equ 0x1dc
Led_RD5  equ 0x1dd
Led_RD6  equ 0x1de
Led_RD7  equ 0x1df

Led_RE0  equ 0x1e0
Led_RE1  equ 0x1e1
Led_RE2  equ 0x1e2
Led_RE3  equ 0x1e3
Led_RE4  equ 0x1e4
Led_RE5  equ 0x1e5
Led_RE6  equ 0x1e6
Led_RE7  equ 0x1e7

Led_RF0  equ 0x1e8
Led_RF1  equ 0x1e9
Led_RF2  equ 0x1ea
Led_RF3  equ 0x1eb
Led_RF4  equ 0x1ec
Led_RF5  equ 0x1ed
Led_RF6  equ 0x1ee
Led_RF7  equ 0x1ef
#endif

#ifdef C12
    var_bank2 A0_A1_reg
    var_bank2 A0_A2_reg
;    var_bank2 A0_A3_reg
    var_bank2 A0_A4_reg
    var_bank2 A0_A5_reg

    var_bank2 A1_A0_reg
    var_bank2 A1_A2_reg
    var_bank2 A1_A3_reg
;    var_bank2 A1_A4_reg
    var_bank2 A1_A5_reg

    var_bank2 A2_A0_reg
    var_bank2 A2_A1_reg
    var_bank2 A2_A3_reg
    var_bank2 A2_A4_reg
;    var_bank2 A2_A5_reg

;    var_bank2 A3_A0_reg
    var_bank2 A3_A1_reg
    var_bank2 A3_A2_reg
    var_bank2 A3_A4_reg
    var_bank2 A3_A5_reg

    var_bank2 A4_A0_reg
;    var_bank2 A4_A1_reg
    var_bank2 A4_A2_reg
    var_bank2 A4_A3_reg
    var_bank2 A4_A5_reg

    var_bank2 A5_A0_reg
    var_bank2 A5_A1_reg
;    var_bank2 A5_A2_reg
    var_bank2 A5_A3_reg
    var_bank2 A5_A4_reg

    var_bank2 B7_B6_reg
    var_bank2 B7_B5_reg
;    var_bank2 B7_B4_reg
    var_bank2 B7_B3_reg
    var_bank2 B7_B2_reg

    var_bank2 B6_B7_reg
    var_bank2 B6_B5_reg
    var_bank2 B6_B4_reg
;    var_bank2 B6_B3_reg
    var_bank2 B6_B2_reg

    var_bank2 B5_B7_reg
    var_bank2 B5_B6_reg
    var_bank2 B5_B4_reg
    var_bank2 B5_B3_reg
;    var_bank2 B5_B2_reg

;    var_bank2 B4_B7_reg
    var_bank2 B4_B6_reg
    var_bank2 B4_B5_reg
    var_bank2 B4_B3_reg
    var_bank2 B4_B2_reg

    var_bank2 B3_B7_reg
;    var_bank2 B3_B6_reg
    var_bank2 B3_B5_reg
    var_bank2 B3_B4_reg
    var_bank2 B3_B2_reg

    var_bank2 B2_B7_reg
    var_bank2 B2_B6_reg
;    var_bank2 B2_B5_reg
    var_bank2 B2_B4_reg
    var_bank2 B2_B3_reg
#endif

#ifndef M8X16
    var_all_bank Ax_dir
#endif
#ifdef C19
    var_all_bank Cx_dir
#endif
#ifdef SRGB
    var_all_bank Cx_dir
#endif
#ifdef C12
    var_all_bank Bx_dir
#endif

;
; This is the number of times the display logic should cycle before exiting. It's been hand timed from the
; start of the interupt to the end to be around 800usec. This leaves 90 usec for the main loop.
; The 19 stick has an extra display line strobe cycle.
;
#ifdef RGB4
    movlw   0x36
#else
#ifdef BI6
    movlw   0x3a
#else
#ifdef S19
    movlw   0x30
#else
#ifdef C19
    movlw   0x18
#else
#ifdef M3X3
    movlw   0x2E
#else
#ifdef SRGB
    movlw   0x18
#else
#ifdef M8X16
    movlw   0x0a
#else
#ifdef C12
    movlw   0x14
#else
    error "unknown board delaytimer"
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif



    movwf   fcount

#ifdef C19
    movlw   b'00101000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir
    clrf    Cx_dir          ;set LED matrix pins to input (tri-stated)
#else
#ifdef SRGB
    movlw   b'00111000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir
    clrf    Cx_dir          ;set LED matrix pins to input (tri-stated)
#else
#ifdef C12
    clrf    Ax_dir     ;set LED matrix pins to input (tri-stated)
    clrf    Bx_dir
#else
#ifndef M8X16
    movlw   b'00001000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir
#endif
#endif
#endif
#endif

    call    get_state_tbl_hi_address
    call    get_state_tbl_low_address
    call    go_state_table
    call    set_max_state

;   turn off the LEDs DDF
    clrf         PORTA
;    clrf         PORTB

    movf         dcycle,w         ; testing for 0
    btfsc        STATUS,Z
    call         display_cycle0

    movlw        0x01             ; testing for 1
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle1

    movlw        0x02             ; testing for 2
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle2

    movlw        0x03             ; testing for 3
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle3

#ifndef BI6
#ifndef RGB4
    movlw        0x04             ; testing for 4
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle4

#ifndef S19
#ifndef M3X3
    movlw        0x05             ; testing for 5
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle5

#ifndef C12
    movlw        0x06             ; testing for 6
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle6

#ifndef C19
#ifndef SRGB
    movlw        0x07             ; testing for 7
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle7

    movlw        0x08             ; testing for 8
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle8

    movlw        0x09             ; testing for 9
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle9

    movlw        0x0a             ; testing for 10
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle10

    movlw        0x0b             ; testing for 11
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle11

    movlw        0x0c             ; testing for 12
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle12

    movlw        0x0d             ; testing for 13
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle13

    movlw        0x0e             ; testing for 14
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle14

    movlw        0x0f             ; testing for 15
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle15
#endif
#endif
#endif
#endif
#endif
#endif
#endif

;--------------------------------------------------------------------------------------
exit_tx
;--------------------------------------------------------------------------------------
#ifdef __16F886
;    clrf       PORTA         ;DDF debug hack               ; turn all the LED off
;    clrf       PORTB         ;DDF debug hack               ; turn all the LED off
;    clrf       PORTC         ;DDF debug hack               ; turn all the LED off
#else
#ifdef MULTIBUTTON
    movlw        b'00110111'
    movwf        PORTA
#else
    clrf       PORTA         ;DDF debug hack               ; turn all the LED off
#endif
#ifndef __12F683
    clrf       PORTC         ;DDF debug hack               ; turn all the LED off
#endif
#endif


;   clear timer0 interupt
    bcf         INTCON,T0IF

; restore state, return form interupt

exit_int
    bsf     INTCON,GIE
#ifdef __12F683
    swapf       status_temp,w
    movwf       STATUS
    swapf       w_temp,f
    swapf       w_temp,w
#else
    movf        fsr_save,w
    movwf       FSR
	movf		pclath_temp,w		; retrieve copy of PCLATH register
	movwf		PCLATH			; restore pre-isr PCLATH register contents	
	movf		status_temp,w		; retrieve copy of STATUS register
	movwf		STATUS			; restore pre-isr STATUS register contents
	swapf		w_temp,f
	swapf		w_temp,w		; restore pre-isr W register content
#endif
    retfie                  ; return from interrupt

#define DEBOUNCE 0x10



#ifdef RGB4
#include <strobe_rgb4.asm>
#else
#ifdef BI6
#include <strobe_bi6.asm>
#else
#ifdef S19
#include <strobe_s19.asm>
#else
#ifdef C19
#include <strobe_c19.asm>
#else
#ifdef M3X3
#include <strobe_m3x3.asm>
#else
#ifdef SRGB
#include <strobe_srgb.asm>
#else
#ifdef M8X16
#include <strobe_m8x16.asm>
#else
#ifdef C12
#include <strobe_c12.asm>
#else
    error "unknown board strobe type"
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif


;**************************************************************************************
;
; State Machine
;
;**************************************************************************************

    var instate
    var max_instate
    var IR_in
    var command
    var address
    var toggle
    var IR_lhalf
    var button
#ifdef M3X3
    var button0
    var button1
    var button2
    var button3
    var button4
#endif
    var tx_1
    var pindex2
    var IR_in_good
    var butcount

;--------------------------------------------------------------------------------------
get_state_tbl_hi_address ; 17 cycles
;--------------------------------------------------------------------------------------
    var tbl2_hi

    bcf          STATUS,0        ; clear carry flag           ; 1
    rlf          instate,w       ; entry = table * 2          ; 2
    movwf        pindex2                                      ; 3
    call         table_lookup2                                ; 14 (9+2)
    movwf        tbl2_hi                                      ; 15
    return                                                    ; 16/17

;--------------------------------------------------------------------------------------
get_state_tbl_low_address  ; 18 cycles
;--------------------------------------------------------------------------------------
    var tbl2_low

    bcf          STATUS,0      ; clear carry flag (just in case)  ; 1
    rlf          instate,w     ; entry = table * 2 + 1            ; 2
    addlw        1                                                ; 3
    movwf        pindex2                                          ; 4
    call         table_lookup2                                    ; 15 (9+2)
    movwf        tbl2_low                                         ; 16
    return                                                        ; 17/18

;**********************************************************************
table_lookup2  ; 9 cycles
;**********************************************************************
    movlw        HIGH state_jump_table                 ; 1
    movwf        PCLATH                                ; 2
    movf         pindex2,w                             ; 3
    addlw        LOW state_jump_table                  ; 4
    btfsc        STATUS,0     ; check carry flag       ; 5
    incf         PCLATH,f                              ; 6
    movwf        PCL                                   ; 7 + 2

;**********************************************************************
go_state_table  ; 18 cycles
;**********************************************************************

    movf         tbl2_hi,w    ; 1
    movwf        PCLATH       ; 2
    movf         tbl2_low,w   ; 3
    movwf        PCL          ; 4

;**********************************************************************
state_jump_table
;**********************************************************************
    make_state_jump_table d'31'

    state_tbl 0, 6, 1, 0
    state_tbl 1, 0, 2, -1
    state_tbl 2, 0, 3, -1
    state_tbl 3, 4, 3, -1
    state_tbl 4, 0, 5, -1
    state_tbl 5, 7, 0, -1

Lstate6
 
     btfsc        IR_in,0
     goto         Lstate6a

     movlw        0
     addwf        butcount,w
     btfsc        STATUS,Z
     goto         Lstate6b

     decfsz       butcount,f
     goto         Lcontinue
     
Lstate6b

#ifndef MULTIBUTTON
     bsf  button,0                          
#endif
     goto         Lcontinue
     
Lstate6a
     clrf        instate
     goto         Lcontinue       

    state2_tbl 7, toggle, 0
    state2_tbl 9, address, 4    
    state2_tbl d'11', address, 3    
    state2_tbl d'13', address, 2    
    state2_tbl d'15', address, 1    
    state2_tbl d'17', address, 0    
    state2_tbl d'19', command, 5    
    state2_tbl d'21', command, 4    
    state2_tbl d'23', command, 3    
    state2_tbl d'25', command, 2    
    state2_tbl d'27', command, 1    
    state2_tbl d'29', command, 0    

Lstate31
    clrf        instate
    bsf         IR_in_good,0    

Lcontinue
    return

;--------------------------------------------------------------------------------------
read_button_in   ; 5 cycles
;--------------------------------------------------------------------------------------
; Portability : hardcoded button port
;
#ifndef SIM_DEBUG
#ifdef M8X16
    bcf         button,1         ; 1
    btfss       PORTC,2          ; 2
    bsf         button,1         ; 3           
#else ; M8X16
#ifndef MULTIBUTTON
    bcf         button,0         ; 1
    bcf         button,1         ; 1
#ifdef DEDICATED_BUTTON2
#ifdef SRGB
    btfss       PORTA,5          ; 2 ; stick has 2 buttons.
    bsf         button,1         ; 3
    btfss       PORTA,4          ; 2
    bsf         button,0         ; 3
#else ; SRGB
    btfss       PORTC,5          ; 2 ; Dual 12C has 2 buttons.
    bsf         button,0         ; 3
    btfss       PORTC,7          ; 2
    bsf         button,1         ; 3
#endif ; SRGB
#else ; DEDICATED_BUTTON2
    btfss       PORTA,5          ; 2
    bsf         button,0         ; 3
#endif ; not DEDICATED_BUTTON2
#endif ; not MULTIBUTTON
#endif ; not M8x16
#endif ; not SIM_DEBUG
    return                        

;--------------------------------------------------------------------------------------
read_ir_in   ; 5 cycles
;--------------------------------------------------------------------------------------

    bcf         IR_in,0         ; 1
#ifndef SIM_DEBUG
#ifdef C12
    btfsc       PORTC,6         ; 2
#else
#ifdef M8X16
    btfsc       PORTE,3         ; 2
#else
    btfsc       PORTA,3         ; 2
#endif
#endif
#endif

    bsf         IR_in,0         ; 3

;    movf        tx_1,w   ; loopback for testing HACK!!        ;1
;    xorlw       0x01       ; loopback for testing HACK!!      ;2
;    movwf       IR_in      ; loopback for testing HACK!!      ;3
    return                                                     ; 4/5

;--------------------------------------------------------------------------------------
set_max_state   ; 5-7 cycles
;--------------------------------------------------------------------------------------
    movf         max_instate,w  
    subwf        instate,w       
    btfss        STATUS,C        
    goto         smi_l1          
    movf         instate,w       
    movwf        max_instate     
smi_l1
    return                       

;--------------------------------------------------------------------------------------
get_next_tx_bit   ; 11 cycles
;--------------------------------------------------------------------------------------

    bcf         tx_1,0                                 ;1
    decf        scount,f                               ;2
    bcf         STATUS, C   ; clear carry bit          ;3
    rrf         out3,f                                 ;4
    rrf         out2,f                                 ;5
    rrf         out1,f                                 ;6
    rrf         out0,f                                 ;7
    btfsc       STATUS, C                              ;8
    bsf         tx_1,0                                 ;9
 
;    movf        tx_1,w   ; loopback for testing HACK!!
;    xorlw       0x01       ; loopback for testing HACK!!
;    movwf       tx_1      ; loopback for testing HACK!!
;    mult_nop d'6'         ; for debuging
  
    return                                             ;10/11

;**********************************************************************
qdelay
;**********************************************************************
    var qcount

    movwf       qcount
delay_loop2
    decfsz      qcount,1
    goto        delay_loop2
    return
;**********************************************************************
rf_command_out
;**********************************************************************

    var out_address
    var out_command
    var out_toggle
    var out_pattern
    var out0
    var out1
    var out2
    var out3
    var scount

    clrf        out1
    clrf        out2
    clrf        out3

;   start flag
    movlw       B'10100000'
    movwf       out0


;   toggle bit
    comf        out_toggle,f                ; toggle the toggle flag
    btfss       out_toggle,0
    bsf         out1,0
    btfsc       out_toggle,0
    bsf         out1,1

;   address bits
    btfss       out_address,4
    bsf         out1,2
    btfsc       out_address,4
    bsf         out1,3

    btfss       out_address,3
    bsf         out1,4
    btfsc       out_address,3
    bsf         out1,5

    btfss       out_address,2
    bsf         out1,6
    btfsc       out_address,2
    bsf         out1,7

    btfss       out_address,1
    bsf         out2,0
    btfsc       out_address,1
    bsf         out2,1

    btfss       out_address,0
    bsf         out2,2
    btfsc       out_address,0
    bsf         out2,3

;   command bits
    btfss       out_command,5
    bsf         out2,4
    btfsc       out_command,5
    bsf         out2,5

    btfss       out_command,4
    bsf         out2,6
    btfsc       out_command,4
    bsf         out2,7

    btfss       out_command,3
    bsf         out3,0
    btfsc       out_command,3
    bsf         out3,1

    btfss       out_command,2
    bsf         out3,2
    btfsc       out_command,2
    bsf         out3,3

    btfss       out_command,1
    bsf         out3,4
    btfsc       out_command,1
    bsf         out3,5

    btfss       out_command,0
    bsf         out3,6
    btfsc       out_command,0
    bsf         out3,7

    movlw       0x21
    movwf       scount

    return

#ifdef BIN2LED
;**********************************************************************
bin2led
;**********************************************************************
    var b2l_out_hi
    var b2l_out_low
    var b2l_lcount
    var b2l_in_red
    var b2l_in_green

    clrf        b2l_out_hi
    clrf        b2l_out_low
    movlw       0x08
    movwf        b2l_lcount
b2l_loop
    bcf         STATUS, C
    rrf         b2l_in_green,f
    rlf         b2l_out_low,f
    rlf         b2l_out_hi,f
    rrf         b2l_in_red,f
    rlf         b2l_out_low,f
    rlf         b2l_out_hi,f

    decfsz      b2l_lcount,f
    goto        b2l_loop
    return
#endif

#ifdef FLIPBYTE
;**********************************************************************
flipbyte
;**********************************************************************
     var flip_in
     var flip_out
     var flip_lcount

     movwf       flip_in
     clrf        flip_out
     movlw       0x08
     movwf       flip_lcount
fbyte_loop
     bcf         STATUS, C
     rrf         flip_in,f
     rlf         flip_out,f
 
     decfsz      flip_lcount,f
     goto        fbyte_loop
 
     movfw       flip_out
     return
#endif
                 
;**********************************************************************
delay
;**********************************************************************

    var         delay_count

;   movlw       0ffh
    movwf       delay_count
delay_loop
    nop
    decfsz      delay_count,1
    goto        delay_loop
    return

;**********************************************************************
next_pattern
;**********************************************************************
    incf         pattern,f
    movf         pattern,w
    sublw        NUM_TAB+1  ; max pattern?
    btfsc        STATUS,2   ; z bit check
    clrf         pattern    ; reset to zero
    movfw        pattern
    movwf        out_pattern
    clrf         pindex
    clrf         pindex1
    return

;**********************************************************************
past_pattern
;**********************************************************************
    decf         pattern,f
    movf         pattern,w
    addlw        1  ; max pattern?
    btfss        STATUS,2   ; z bit check
    goto         past_exit
    movlw        NUM_TAB
    movwf        pattern
    movwf        out_pattern
past_exit
    clrf         pindex
    clrf         pindex1
    return

;**********************************************************************
set_pattern         ;set pattern from IR
;**********************************************************************
; extra logic because all the different blinkes talk to each other, but
; do not have the same number of patterns. So if blinkie "A" sents a
; pattern 22 to blinkie "B" which only has 10 patterns, Blinkie "B"
; starts to show pattern 2. (22 % 10 a mod function.) But to make
; things fair in blinkie wars, it will transmit pattern 22 to other
; blinkies.
;**********************************************************************

    movfw        command
    movwf        pattern
    movwf        out_pattern
set_loop
    addlw        0xff-NUM_TAB
    btfss        STATUS, C
    goto         set_exit

    movlw        NUM_TAB
    subwf        pattern,f
    movfw        pattern
    goto         set_loop

set_exit
    clrf         pindex
    clrf         pindex1
    return

;**********************************************************************
strobe_delay
;**********************************************************************

    var          strobe_count

    movwf        strobe_count
strobe_delay1
    bcf          nextf,0

strobe_delay2
    btfss        nextf,0
    goto         strobe_delay2

    decfsz       strobe_count,f
    goto         strobe_delay1

    return

#ifdef M8X16
#include display_pattern_id_8x16.asm
#else
;**********************************************************************
display_pattern_id
;**********************************************************************

    incf         pattern,w      ; W = pattern + 1
#ifdef SRGB
    movwf        in1
    clrf         in0
    clrf         in2
    clrf         in3
    clrf         in4
    clrf         in5
#else
#ifdef C12
    call         flipbyte
    movwf        in0
    clrf         in1
    clrf         in2
    clrf         in3
    clrf         in4
    clrf         in5
    movlw        b'01110000'
    btfsc        demo_mode,0
    movwf        in1  
#else
    movwf        in0
#endif
#endif

#ifdef S19
    call         flipbyte
    movwf        in0
#endif
#ifdef BI6
#ifdef MONO
    call         flipbyte
    movwf        in0
#else
    movwf        b2l_in_green
    clrf         b2l_in_red
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in0
    movf         b2l_out_low,w
    movwf        in1
#endif
#endif

#ifdef M3X3
    movwf        b2l_in_green
    clrf         b2l_in_red
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in0
    movf         b2l_out_low,w
    movwf        in1
#endif

#ifdef C19
;   outer ring hars the pattern number
    movwf        b2l_in_red
    clrf         b2l_in_green
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in0
    movf         b2l_out_low,w
    movwf        in1

;   center LED turned on
    clrf         in2          
    clrf         in3
    movlw        b'00001100'  
    movwf        in4

;   middle ring on if demo mode
    btfss        demo_mode,0
    goto         skip4

    comf         in3,f
    movlw        b'11111100'  
    movwf        in4
skip4

#endif

#ifdef M3X3
    clrf        in2

    movlw        b'11100000'
    btfsc        demo_mode,0
    movwf        in2  
#endif

#ifdef S19
    clrf        in1
    clrf        in2

    movlw        b'11100000'
    btfsc        demo_mode,0
    movwf        in2    
#else
#ifdef BI6
#ifdef MONO
    btfsc        demo_mode,0
    bsf          in0,2  
#else  ; bicolor
    btfsc        demo_mode,0
    bsf          in1,4  
#endif ; end Mono/bicolor
#endif ; end BI
#endif ; end S19/BI6

#ifdef RGB4
    btfsc        demo_mode,0
    bsf          in1,7  
#endif
#ifdef SRGB
    movlw        b'00111000'
    btfsc        demo_mode,0
    movwf        in4 
#endif

    movlw        0xFF
    call         display_1bit

    clrf         in0
    clrf         in1
    clrf         in2
    movlw        0x01
    call         display_1bit
    return
#endif
;**********************************************************************
setup_pattern_table
;**********************************************************************
    var tbl_hi
    var tbl_low
    var temp_high

;slabel1
;
;   Set the pattern (table)
;
    movlw        HIGH MasterTable
    movwf        tbl_hi
    movlw        LOW MasterTable
    movwf        tbl_low

;   get the high address for the pattern table
    bcf          STATUS,0      ; clear carry flag
    rlf          pattern,w     ; entry = table * 2
    movwf        pindex
    bcf          INTCON, GIE      ; disable INTs
    call         table_lookup
    bsf          INTCON, GIE      ; enable INTs
    movwf        temp_high          ; can't put it in tbl_high yet

;   get the low address for the pattern table
    bsf          STATUS,0      ; set carry
    rlf          pattern,w     ; entry = table * 2 + 1
    movwf        pindex
    bcf          INTCON, GIE      ; disable INTs
    call         table_lookup
    bsf          INTCON, GIE      ; enable INTs
    movwf        tbl_low

    movf         temp_high,w
    movwf        tbl_hi

sreturn
    return

;**********************************************************************
get_next_pattern_entry
;**********************************************************************
    var          pclath_save
    var          temp2

#ifndef NOEEPROM
;   if hi address is 0x21 pattern is in eeprom   
    movlw        0x21
    subwf        tbl_hi,w
    btfss        STATUS,Z
    goto         glabel1

;   table in eeprom
    movfw        tbl_low
    addwf        pindex,w

    call         read_eeprom
    
    goto         greturn
#endif

;   table in program memory
glabel1
    bcf          INTCON, GIE      ; disable INTs
    movfw        PCLATH
    movwf        pclath_save

    movfw        tbl_hi
    addwf        pindex1,w
    movwf        offset_hi

    bcf          STATUS,C
    movfw        tbl_low
    addwf        pindex,w
    movwf        offset_low

    btfsc        STATUS,C
    incf         offset_hi,f
    call         jump_address

    movwf        temp2
    movfw        pclath_save
    movwf        PCLATH
    movfw        temp2
    bsf          INTCON, GIE      ; enable INTs

greturn
    incfsz       pindex,f
    goto         gskip
    incf         pindex1,f
gskip
    return

#ifndef NOEEPROM

;**********************************************************************
write_eeprom
;   expects EEPROM address and data in pindex and input
;   makes sure previous write (if any) has completed before proceeding
;**********************************************************************
    BANKSEL EECON1

    btfsc   EECON1,WR       ;wait for WR to clear
    goto    $-1

    bcf          INTCON, GIE      ; disable INTs
    bsf     EECON1,WREN     ;enable writes
    BANKSEL EEADR
    movf    pindex,w        ;set address
    movwf   EEADR
    movf    input,w         ;set data
    movwf   EEDAT
    BANKSEL EECON1
    movlw   0x55            ;EECON2 = 0x55  ;unlock sequence
    movwf   EECON2
    movlw   0xAA            ;EECON2 = 0xAA  ;unlock sequence
    movwf   EECON2
    bsf     EECON1,WR       ;initiate a write cycle
    bsf          INTCON, GIE      ; enable INT

    setbank0
    return


;**********************************************************************
read_eeprom
;   expects EEPROM address in W
;   returns EEPROM data in W
;   makes sure previous write (if any) has completed before proceeding
;**********************************************************************
    bcf     INTCON, GIE      ; disable INTs

    BANKSEL EECON1
    btfsc   EECON1,WR       ;wait for WR to clear
    goto    $-1

    bcf     EECON1,WREN     ;disable writes
    BANKSEL EEADR
    movwf   EEADR           ;EEADR = W
    BANKSEL EECON1
    bcf     EECON1,7        ;clear EEPGD
    bsf     EECON1,RD       ;initiate a read cycle
    BANKSEL EEDAT
    movf    EEDAT,w         ;W = EEDAT

    setbank0
    bsf          INTCON, GIE      ; enable INT
    return
#endif

;**********************************************************************
read_demo_mode
;**********************************************************************
#ifndef NOEEPROM
    movlw        LOW demo_store
    call         read_eeprom
#else
    movlw        0x00
#endif
	movwf        demo_mode
    return

;**********************************************************************
toggle_demo
;**********************************************************************
    call         read_demo_mode
#ifndef NOEEPROM
    btfss        demo_mode,0          ;
    goto         tdemo_on

;   toggle off
    bcf          demo_mode,0
    goto         tdemo_cont

tdemo_on
    bsf          demo_mode,0

tdemo_cont
    movlw        LOW demo_store
    movwf        pindex
    movfw        demo_mode
    movwf        input
    call         write_eeprom

    call         display_pattern_id
    call         display_pattern_id
#endif
    return

;**********************************************************************
pattern_driver
;**********************************************************************

    var pattern
    var tbltype
    var in0
    var in1
    var in2
#ifdef C12
    var in3
    var in4
    var in5
#endif
#ifdef C19
    var in3
    var in4
    var in5
    var in6
    var in7
    var in8
    var in9
#endif
#ifdef SRGB
    var in3
    var in4
    var in5
    var in6
    var in7
    var in8
    var in9
    var in10
    var in11
    var in12
#endif
#ifdef BADGE
    var in3
#endif
#ifdef M8X16
   var in3
   var in4
   var in5
   var in6
   var in7
   var in8
   var in9
   var ina
   var inb
   var inc
   var ind
   var ine
   var inf
   var in10
   var in11
   var in12
   var in13
   var in14
   var in15
   var in16
   var in17
   var in18
   var in19
   var in1a
   var in1b
   var in1c
   var in1d
   var in1e
   var in1f
#endif
    var speed
    var pspeed
    var demo_mode
    var psize

    ; need to be able to access from page1 & page2 for eeprom read/write
    var_all_bank pindex          ; pattern index
    var_all_bank pindex1         ; pattern index
    var_all_bank input

ptop


    call         setup_pattern_table

    clrf         pindex
    clrf         pindex1

;   load the table type  (Currently only 1 type)
    call         get_next_pattern_entry
    movwf        tbltype
    bcf          tbltype,7     ; using top bit for demo mode.

;   load the speed (someday this will be a table type 1 only thing.)
    call         get_next_pattern_entry
    movwf        pspeed
    incf         pspeed,f          ; adjust so 0 is fastest, not treated like speed 256

; load the table size
    call         get_next_pattern_entry ;4rgb
    movwf        psize                  ;4rgb

ploop0
;
;   Check for IR command in
;
    btfss        IR_in_good,0
    goto         button_check

blinkie_check
    movlw        0x07              ; blinkines use address 0x07 (Experimental)
    subwf        address,w
    btfss        STATUS,Z
    goto         remote_check    

    call         set_pattern
    clrf         IR_in_good
    goto         ptop

remote_check
    movf         address,f         ; remote giving "0" for address (TV)?
    btfss        STATUS,Z
    goto         button_check

    movlw        0x20              ; remote curser right (pattern ++)
    subwf        command,w
    btfsc        STATUS,Z
    call         next_pattern

    movlw        0x21              ; remote curser left (pattern --)
    subwf        command,w
    btfsc        STATUS,Z
    call         past_pattern

    movlw        0x00              ; remote "0" key  (pattern = 0)
    subwf        command,w
    btfsc        STATUS,Z
    clrf         pattern

    movlw        0x0c              ; remote on/off key (togle demo mode!)
    subwf        command,w
    btfsc        STATUS,Z
    call         toggle_demo

    clrf         IR_in_good
    goto         ptop

button_check
; ploop1

    movfw        button      ; if any putton pressed show pattern id
    btfsc        STATUS,Z
    goto         ploop2

    call         display_pattern_id
    call         display_pattern_id

ploop1a

#ifdef M3X3
    movlw        0x03              ; if button 3 & 4 presses
    subwf        button,w
    btfsc        STATUS,Z
    goto         mode_loop

    movlw        0x0C              ; if button 1 & 2 presses
    subwf        button,w
    btfsc        STATUS,Z
    call         toggle_demo   

#endif

#ifdef M8X16
    movlw        0x03              ; if both buttons pressed
    subwf        button,w
    btfsc        STATUS,Z
    call         toggle_demo   
#endif
#ifdef C12
    movlw        0x03              ; if both buttons pressed
    subwf        button,w
    btfsc        STATUS,Z
    call         toggle_demo   
#endif


    btfsc        button,0    ; if button 3 pressed inc pattern
    goto         ploop1up

    btfsc        button,1    ; if button 4 pressed dec pattern
    goto         ploop1down

    goto         ptop

ploop1up
    call         next_pattern
    call         display_pattern_id
    call         display_pattern_id
    goto         ploop1a

ploop1down
    call         past_pattern
    call         display_pattern_id
    call         display_pattern_id
    goto         ploop1a
ploop2

#ifdef PATTERN1
    movlw        0x01              ; pattern1
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_1
#endif

#ifdef PATTERN2
    movlw        0x02              ; pattern2
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_2
#endif

#ifdef PATTERN3
    movlw        0x03              ; pattern3
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_3
#endif

#ifdef PATTERN4
    movlw        0x04              ; pattern4
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_4
#endif

#ifdef PATTERN5
    movlw        0x05              ; pattern5
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_5
#endif

#ifdef PATTERN6
    movlw        0x06              ; pattern6
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_6
#endif

#ifdef PATTERN7
    movlw        0x07              ; pattern7
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_7
#endif

#ifdef PATTERN8
    movlw        0x08              ; pattern8
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_8
#endif

#ifdef PATTERN9
    movlw        0x09              ; pattern9
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_9
#endif

#ifdef PATTERN10
    movlw        0x0A              ; pattern10
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_10
#endif

#ifdef PATTERN11
    movlw        0x0B              ; pattern11
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_11
#endif

#ifdef PATTERN12
    movlw        0x0C              ; pattern12
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_12
#endif

#ifdef PATTERN13
    movlw        0x0D              ; pattern13
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_13
#endif

#ifdef PATTERN14
    movlw        0x0E              ; pattern14
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_14
#endif

#ifdef PATTERN15
    movlw        0x0F              ; pattern15
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_15
#endif

#ifdef PATTERN16
    movlw        0x10              ; pattern16
    subwf        tbltype,w
    pageselw     table_type_16
    btfsc        STATUS,Z
    call         table_type_16
    pageselw     pattern_driver
#endif

#ifdef PATTERN17
    movlw        0x11              ; pattern17
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_17
#endif

#ifdef PATTERN18
    movlw        0x12              ; pattern18
    subwf        tbltype,w
    pageselw     table_type_18
    btfsc        STATUS,Z
    call         table_type_18
    pageselw     pattern_driver
#endif

#ifdef PATTERN19
    movlw        0x13              ; pattern19
    subwf        tbltype,w
    pageselw     table_type_19
    btfsc        STATUS,Z
    call         table_type_19
    pageselw     pattern_driver
#endif

#ifdef PATTERN20
    movlw        0x14              ; pattern20
    subwf        tbltype,w
    pageselw     table_type_20
    btfsc        STATUS,Z
    call         table_type_20
    pageselw     pattern_driver
#endif

#ifdef PATTERN21
    movlw        0x15              ; pattern21
    subwf        tbltype,w
    pageselw     table_type_21
    btfsc        STATUS,Z
    call         table_type_21
    pageselw     pattern_driver
#endif

#ifdef PATTERN22
    movlw        0x16              ; pattern22
    subwf        tbltype,w
    pageselw     table_type_22
    btfsc        STATUS,Z
    call         table_type_22
    pageselw     pattern_driver
#endif

#ifdef PATTERN23
    movlw        0x17              ; pattern23
    subwf        tbltype,w
    pageselw     table_type_23
    btfsc        STATUS,Z
    call         table_type_23
    pageselw     pattern_driver
#endif

#ifdef PATTERN24
    movlw        0x18              ; pattern24
    subwf        tbltype,w
    pageselw     table_type_24
    btfsc        STATUS,Z
    call         table_type_24
    pageselw     pattern_driver
#endif

#ifdef PATTERN25
    movlw        0x19              ; pattern25
    subwf        tbltype,w
    pageselw     table_type_25
    btfsc        STATUS,Z
    call         table_type_25
    pageselw     pattern_driver
#endif

#ifdef PATTERN26
    movlw        0x1a              ; pattern26
    subwf        tbltype,w
    pageselw     table_type_26
    btfsc        STATUS,Z
    goto         table_type_26
    pageselw     pattern_driver
#endif

#ifdef PATTERN27
    movlw        0x1b              ; pattern27
    subwf        tbltype,w
    pageselw     table_type_27
    btfsc        STATUS,Z
    goto         table_type_27
    pageselw     pattern_driver
#endif

pattern_return

;   make sure we are not sending a IR signel
    movf        scount,w                    ; F22
    addlw       0                           ; F23
    btfss       STATUS,Z                    ; F24
    goto        ploop3

;   count down till net IR signel
    btfss       nextf,1
    goto        ploop3

    bcf         nextf,1
    btfss       demo_mode,0
    goto        ploop2a

    call        next_pattern
    goto        ptop
   
ploop2a
;   send an IR signel
#ifdef ENABLE_IR
    movlw       0x07                        ; address 0x07 "Experimental"
    movwf       out_address
    movfw       out_pattern
    movwf       out_command                 ; copy out_pettern

    call        rf_command_out 
#endif

ploop3
    decfsz  psize,f     ;check for end of pattern (4rgb)
    goto    ploop0

    goto        ptop

#ifdef PATTERN1
#include pattern_01.asm
#endif

#ifdef PATTERN2
#include pattern_02.asm
#endif


#ifdef PATTERN3
#include pattern_03.asm
#endif


#ifdef PATTERN4
#include pattern_04.asm
#endif

#ifdef PATTERN5
;**********************************************************************
table_type_5
;**********************************************************************
;
;  1 bytes
;
;  ABCDEFX = 7 bits for LEDs.
;

    var p2count

    call         get_next_pattern_entry
    movwf        in0

    movlw        0x04       ; call display 4 times, speed thing
    movwf        p2count

p2loop
    movfw        pspeed
    call         display_1bit

    decfsz       p2count,f
    goto         p2loop

    return
#endif

#ifdef PATTERN6
;**********************************************************************
table_type_6
;**********************************************************************
;
;  3 bytes
;
;  AAAAAAAA AAAAAAAA AAADDDDD
;
;  A = 19 bits of LED
;  DDDDD = a repeat counter.

    var p2count

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2

    movlw        b'00011111'
    andwf        in2,w
    movwf        p2count
    incf         p2count,f
    rlf          p2count,f
    rlf          p2count,f

p2loop
    movfw        pspeed
    call         display_1bit

    decfsz       p2count,f
    goto         p2loop

    return
#endif

#define BRIGHT1 0x40
#define BRIGHT2 0xA0

#ifdef PATTERN7
#include pattern_07.asm
#endif

#ifdef PATTERN19
#include pattern_19.asm
#endif


#ifdef PATTERN8
;**********************************************************************
table_type_8 ; - 19 LED fader
;**********************************************************************

    var          delay1
    var          fad
    var          color


    incf         delay1,f

    movf         delay1,w         ; testing for 0
    btfss        STATUS,Z
    goto         cf8_loop2a

    movlw        TICK_VALUE     ; we are using timer0 for the counts, 0 through tick value is LED off.
    movwf        delay1 
   
;
;   select a pattern
;
    comf         fad,f
    movf         fad,w         ; testing for 0
    btfss        fad,0
    incf         color,f

    movlw        0xFD             ; testing for greater then 3 
    addwf        color,w
    btfsc        STATUS,C
    clrf         color

#ifdef M3X3
    nop
cf8_loop2a
	clrf		 A4_A0_reg        ; 1G
	clrf		 A5_A0_reg        ; 2G
	clrf		 A5_A1_reg        ; 3G
	clrf		 A2_A0_reg        ; 4G
	clrf		 A4_A2_reg        ; 5G
	clrf		 A5_A2_reg        ; 6G
	clrf	 	 A1_A0_reg        ; 7G
	clrf		 A4_A1_reg        ; 8G
	clrf		 A5_A4_reg        ; 9G
	clrf		 A0_A4_reg        ; 1R
	clrf		 A0_A5_reg        ; 2R
	clrf	 	 A1_A5_reg        ; 3R
	clrf	 	 A0_A2_reg        ; 4R
	clrf	 	 A2_A4_reg        ; 5R
	clrf		 A2_A5_reg        ; 6R
	clrf		 A0_A1_reg        ; 7R
	clrf		 A1_A4_reg        ; 8R
	clrf		 A4_A5_reg        ; 9R

    movf        delay1,w         ; fading up
    btfsc       fad,0
	comf        delay1,w         ; fading down

    btfsc        color,0
    goto         t8_skip_r

	movwf		 A4_A0_reg        ; 1G
	movwf		 A5_A0_reg        ; 2G
	movwf		 A5_A1_reg        ; 3G
	movwf		 A2_A0_reg        ; 4G
	movwf		 A4_A2_reg        ; 5G
	movwf		 A5_A2_reg        ; 6G
	movwf	 	 A1_A0_reg        ; 7G
	movwf		 A4_A1_reg        ; 8G
	movwf		 A5_A4_reg        ; 9G

t8_skip_r
    btfsc        color,1
    goto         t8_skip_g

	movwf		 A0_A4_reg        ; 1R
	movwf		 A0_A5_reg        ; 2R
	movwf	 	 A1_A5_reg        ; 3R
	movwf	 	 A0_A2_reg        ; 4R
	movwf	 	 A2_A4_reg        ; 5R
	movwf		 A2_A5_reg        ; 6R
	movwf		 A0_A1_reg        ; 7R
	movwf		 A1_A4_reg        ; 8R
	movwf		 A4_A5_reg        ; 9R
t8_skip_g

#else

    nop
cf8_loop2a
    movf        delay1,w         ; fading up
    btfsc       fad,0
	comf        delay1,w         ; fading down

	movwf		 A5_A0_reg        ; 01
	movwf		 A2_A5_reg        ; 02
	movwf		 A5_A2_reg        ; 03
	movwf		 A4_A5_reg        ; 04
	movwf		 A5_A4_reg        ; 05
	movwf	 	 A1_A5_reg        ; 06
	movwf		 A5_A1_reg        ; 07
    movwf		 A2_A0_reg        ; 08
	movwf	 	 A0_A2_reg        ; 09
	movwf		 A4_A0_reg        ; 10
	movwf		 A0_A4_reg        ; 11
	movwf	 	 A1_A0_reg        ; 12
	movwf		 A0_A1_reg        ; 13
	movwf		 A4_A2_reg        ; 14
	movwf	 	 A2_A4_reg        ; 15 
	movwf		 A1_A2_reg        ; 16 
	movwf		 A2_A1_reg        ; 17 
	movwf		 A1_A4_reg        ; 18
	movwf		 A4_A1_reg        ; 19 
#endif

    movlw       0x03
    call        strobe_delay

    return
#endif

#ifdef PATTERN9
;**********************************************************************
table_type_9
;**********************************************************************
;
;  5 bytes
;  00000000 00000000 00111111 11111111 111111XX
;  11223344 55667788 99001122 33445566 778899XX
;  RGRGRGRG RGRGRGRG RGRGRGRG RGRGRGRG RGRGRGXX
;
;  XX = a repeat counter.

    var p2count

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2

    call         get_next_pattern_entry
    movwf        in3

    call         get_next_pattern_entry
    movwf        in4

    movlw        b'00000011'
    andwf        in4,w
    movwf        p2count
    incf         p2count,f
    rlf          p2count,f
    rlf          p2count,f

p2loop
    movfw        pspeed
    call         display_1bit

    decfsz       p2count,f
    goto         p2loop

    return
#endif

#ifdef PATTERN10
;**********************************************************************
table_type_10
;**********************************************************************
; 76543210 <-- bits
; AABBCCDD <-- LEDs
; 01010101 <-- stays on for 1 unit  - b'01'
; 10101010 <-- stays on for 2 units - b'10'
; 11111111 <-- stays on for 3 units - b'11'

; in0 LEDs 0,1
; in1 LEDs 2,3
; in2 LEDs 4,5
; in3 LED  6

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry     ;4rgb
    movwf        in2                        ;4rgb

    call         get_next_pattern_entry     ;4rgb
    movwf        in3                        ;4rgb



    movf         pspeed,w
    movwf        speed
    call         display_2bit

    return
#endif

#ifdef PATTERN11
;**********************************************************************
table_type_11
;**********************************************************************
; 76543210 <-- bits
; AABBCCDD <-- LEDs
; 01010101 <-- stays on for 1 unit  - b'01'
; 10101010 <-- stays on for 2 units - b'10'
; 11111111 <-- stays on for 3 units - b'11'

; in0 LEDs 0,1,3,4
; in1 LEDs 5,6,C

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    movf         pspeed,w
    movwf        speed
    call         display_2bit

    return
#endif

#ifdef RANDOM

;**********************************************************************
gen_random
;**********************************************************************

   var     random

   RLF     random,W
   RLF     random,W
   BTFSC   random,4
   XORLW   1
   BTFSC   random,5
   XORLW   1
   BTFSC   random,3
   XORLW   1
   MOVWF   random
   return
#endif

#ifdef PATTERN12
;**********************************************************************
table_type_12
;**********************************************************************
;
    dupvar  p12_count, b2l_out_hi

    movlw        in0            ; shift down in1f->in0
    movwf        FSR
    bcf          STATUS,IRP

#ifdef M8X16
    movlw        0x20
#else
    movlw        0x04
#endif

    movwf        p12_count

p12_loop
    call         gen_random
    call         gen_random
    call         gen_random
    call         gen_random
    call         gen_random
    movwf        INDF
    incf         FSR,f
      
    decfsz       p12_count,f
    goto         p12_loop

    movfw        pspeed
    call         display_1bit

    return
#endif ; PATTERN12

#ifdef PATTERN13
;**********************************************************************
table_type_13
;**********************************************************************
;
;  10 bytes
;  11112222 33334444 55556666 77778888 99990000 11112222 33334444 55556666 77778888 9999XXXX   
;
;  XX = a repeat counter.

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2

    call         get_next_pattern_entry
    movwf        in3

    call         get_next_pattern_entry
    movwf        in4

    call         get_next_pattern_entry
    movwf        in5

    call         get_next_pattern_entry
    movwf        in6

    call         get_next_pattern_entry
    movwf        in7

    call         get_next_pattern_entry
    movwf        in8

    call         get_next_pattern_entry
    movwf        in9

    movlw        b'00001111'
    andwf        in9,w
    movwf        p2count
    incf         p2count,f
    rlf          p2count,f
    rlf          p2count,f

p3loop
    movfw        pspeed
    call         display_2bit

    decfsz       p2count,f
    goto         p3loop

    return
#endif

#ifdef PATTERN14
;**********************************************************************
table_type_14
;**********************************************************************
;
;  5 bytes
;  11223344 55667788 99001122 33445566 778899XX   
;
;  XX = a repeat counter.

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2

    call         get_next_pattern_entry
    movwf        in3

    call         get_next_pattern_entry
    movwf        in4

    movlw        b'00000011'
    andwf        in4,w
    movwf        p2count
    incf         p2count,f
    rlf          p2count,f
    rlf          p2count,f

p3loop
    movfw        pspeed
    call         display_2bit

    decfsz       p2count,f
    goto         p3loop

    return
#endif

#ifdef PATTERN15
;**********************************************************************
table_type_15
;**********************************************************************
;
;  6 bytes
;      0       1         2        3        4       5
;  DDRRRRRR RRRRRRRR XXGGGGGG GGGGGGGG XXBBBBBB BBBBBBBB
;  xx111110 00000000 xx111110 00000000 xx111110 00000000
;  xx432109 87654321 xx432109 87654321 xx432109 87654321  
;  
;  DD = delay counter
;  XX = not used
    var p2count

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2

    call         get_next_pattern_entry
    movwf        in3

    call         get_next_pattern_entry
    movwf        in4

    call         get_next_pattern_entry
    movwf        in5

    movlw        b'11000000'
    andwf        in0,w
    movwf        p2count
    bcf          STATUS, C	
    rrf          p2count,f
    rrf          p2count,f
    rrf          p2count,f
    rrf          p2count,f
    rrf          p2count,f
    rrf          p2count,f
    incf         p2count,f

p3loop
    movfw        pspeed
    call         display_1bit

    decfsz       p2count,f
    goto         p3loop

    return
#endif

#ifdef PATTERN17
#include "pattern_17.asm"
#endif

#ifdef PATTERN22
;**********************************************************************
table_type_22
;**********************************************************************
;
;  32 bytes
;
;  AAAABBBB
;
;  A = shire Right/Left
;  BB = two bit intensity to shift on
;  CCCCC = Number of shifts to loop
;
;  if CCCCC = 0x11111, specical case: turn all LEDs off.
;
    var fcount1 ;, b2l_out_hi

    movlw        in0
    movwf        FSR
    bcf          STATUS,IRP

    movlw        0x20
    movwf        fcount1

t22_loop
    call         get_next_pattern_entry
    movwf        INDF
    incf         FSR,f
    decfsz       fcount1,f
    goto         t22_loop

    movfw        pspeed
    call         display_1bit
    movfw        pspeed
    call         display_1bit
    movfw        pspeed
    call         display_1bit
    movfw        pspeed
    call         display_1bit

    return
#endif

#ifdef PATTERN23
;**********************************************************************
table_type_23
;**********************************************************************
;
;  3 bytes
;
;  AAAAAAAA AAAAAAAA AAADDDDD
;
;  A = 19 bits of LED
;  DDDDD = a repeat counter.

    var p2count

    call         get_next_pattern_entry
    movwf        in0
  
    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2

    call         get_next_pattern_entry
    movwf        in3
  
    call         get_next_pattern_entry
    movwf        in4

    call         get_next_pattern_entry
    movwf        in5

    movlw        0x30
    movwf        p2count

p2loop
    movfw        pspeed
    call         display_1bit

    decfsz       p2count,f
    goto         p2loop

    return
#endif

#ifdef M8X16
;**********************************************************************
shift_left
;**********************************************************************
;
;  shift the in1f->in1e->in1d->....->in1->in0
;

    movlw        in0            ; shift down in1f->in0
    movwf        FSR
    bcf          STATUS,IRP

    movlw        0x1f
    movwf        fcount1

t23_loop
    incf         FSR,f
    movfw        INDF     ; get n    
    decf         FSR,f
    movwf        INDF     ; put n+1
    incf         FSR,f
      
    decfsz       fcount1,f
    goto         t23_loop

    return
#endif

#ifdef PATTERN24
;**********************************************************************
table_type_24
;**********************************************************************
;
;  2 bytes
;
;  shift_left
;  load new in1f and inf
;  display
;

    call         shift_left

    movlw        inf              ; load new inf
    movwf        FSR
    call         get_next_pattern_entry
    movwf        INDF

    movlw        in1f             ; load new in1f
    movwf        FSR
    call         get_next_pattern_entry
    movwf        INDF

    movfw        pspeed           ; display
    call         display_1bit
    movfw        pspeed
    call         display_1bit
    movfw        pspeed
    call         display_1bit
    movfw        pspeed
    call         display_1bit

    return
#endif

#ifdef PATTERN25
;**********************************************************************
table_type_25
;**********************************************************************
;
;
;   get the char
;   lookup char line count
;   loop char count
;      shift_left
;      load char line
;      display
;   endloop
;

    dupvar char_in, b2l_out_hi
    dupvar char_color, b2l_out_low
    dupvar tentry, b2l_lcount
    dupvar char_words, b2l_in_red
;
;  offset = chartabel + (char_in - 0x20) * 6 + char_offset
;  offset = chartabel + (char_in - 0x20) + ((char_in - 0x21) * 4) + char_offset <<1
;  offset = chartabel + (char_in - 0x20) + ((char_in - 0x21) <<2) + char_offset <<1
;  12 bit            12 bit      7 bit              9 bit                    4 bit

   call         get_next_pattern_entry

   movwf        char_in
   movf         char_in,f         ; test for zero

   movlw        0x20              ; color code?
   subwf        char_in,w
   
   btfsc        STATUS,C
   goto         skipt3

   movf         char_in,w         ; get color, then pull next entry
   movwf        char_color
   goto         p25_return

skipt3
; char_in = char_in - 0x20
   movlw        0x20              
   subwf        char_in,f        

; offset = chartabel
   movlw        LOW chartable     
   movwf        offset_low 
   movlw        HIGH chartable
   movwf        offset_hi

; offset = offset + char_in <<1
   movf         char_in,w
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in,w           
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f   

; char_in << 2 ; if carry offset_hi++         
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in, f
   rlf          char_in, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f 

; offset = offset + char_in
   movf         char_in,w           ; offset = offset + char_in
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f     

   bcf          INTCON, GIE      ; disable INTs
   call         jump_address
   movwf        char_words

   movf         pclath_save,w
   movwf        PCLATH
   bsf          INTCON, GIE      ; enable INTs

; offset = offset + 1
   movlw        1
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f

p25_looper

   bcf          INTCON, GIE      ; disable INTs
   call         jump_address
   movwf        tentry

   movf         pclath_save,w
   movwf        PCLATH
   bsf          INTCON, GIE      ; enable INTs

; -------------------
    call shift_left

    movf  tentry, w
    movwf in1f

    movf  tentry, w
    movwf inf

   btfss        char_color,0     ; color adjust
   clrf         in1f

   btfss        char_color,2
   clrf         inf

   btfsc        char_color,1     ; color adjust
   comf         in1f,f

   btfsc        char_color,3
   comf         inf,f
   
; ------------------

; offset = offset + 1
   movlw        1
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f

   movfw        pspeed           ; display
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit

   decfsz       char_words,f
   goto         p25_looper

;  add a blank line after the char and display (spacing)    
   call shift_left
   clrf         in1f
   clrf         inf

   btfsc        char_color,1     ; color adjust
   comf         in1f,f

   btfsc        char_color,3
   comf        inf,f
;--

   movfw        pspeed           ; display
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit
   movfw        pspeed
   call         display_1bit

p25_return
   return

#endif

#ifdef PATTERN26
#include "pattern_26.asm"
#endif


#ifdef DISPLAY_1BIT_A
;**********************************************************************
display_1bit  ; Mono 6 LEDs, Badge LED add center (IR) for 7
;**********************************************************************

    movwf        speed              ;w has the speed/delay

	clrf		 Ar_reg
    btfsc        in0,7
    comf         Ar_reg,f
 
	clrf	 	 Ag_reg
    btfsc        in0,5
    comf         Ag_reg,f

	clrf		 Ab_reg
    btfsc        in0,3
	comf		 Ab_reg,f

	clrf		 Cr_reg
    btfsc        in0,6
	comf		 Cr_reg,f
 
	clrf	 	 Cg_reg
    btfsc        in0,4
	comf	 	 Cg_reg,f

	clrf		 Cb_reg
    btfsc        in0,2
	comf		 Cb_reg,f

#ifdef BADGE
	clrf		 Center_reg
    btfsc        in0,1
	comf		 Center_reg,f
#endif


    movf         speed,w
    call         strobe_delay

    return
#endif
#ifdef DISPLAY_1BIT_B
#include display_1bit_b.asm
#endif
#ifdef DISPLAY_1BIT_C
;**********************************************************************
display_1bit ; 12 LEDs, BI6 & 4RGB Badge LED add center (IR) for 13
;**********************************************************************

    movwf        speed              ;w has the speed/delay

	clrf		 Ar_reg
    btfsc        in0,7
    comf         Ar_reg,f
 
	clrf	 	 Ag_reg
    btfsc        in0,3
    comf         Ag_reg,f

	clrf		 Ab_reg
    btfsc        in1,7
	comf		 Ab_reg,f

	clrf		 Br_reg
    btfsc        in0,6
	comf		 Br_reg,f
 
	clrf	 	 Bg_reg
    btfsc        in0,2
	comf	 	 Bg_reg,f

	clrf		 Bb_reg
    btfsc        in1,6
	comf		 Bb_reg,f

	clrf		 Cr_reg
    btfsc        in0,5
	comf		 Cr_reg,f
 
	clrf	 	 Cg_reg
    btfsc        in0,1
	comf	 	 Cg_reg,f

	clrf		 Cb_reg
    btfsc        in1,5
	comf		 Cb_reg,f

	clrf		 Dr_reg
    btfsc        in0,4
	comf		 Dr_reg,f
 
	clrf	 	 Dg_reg
    btfsc        in0,0
	comf	 	 Dg_reg,f

	clrf		 Db_reg
    btfsc        in1,4
	comf		 Db_reg,f

#ifdef BADGE
	clrf		 Center_reg
    btfsc        in1,3
	comf		 Center_reg,f
#endif

    movf         speed,w
    call         strobe_delay

    return
#endif
#ifdef DISPLAY_1BIT_D
;**********************************************************************
display_1bit ; 20 LEDs
;**********************************************************************

    movwf        speed              ;w has the speed/delay

	clrf		 A0_A5_reg         ; IR

	clrf		 A5_A0_reg        ; 01
    btfsc        in0,7
	comf		 A5_A0_reg,f

	clrf		 A2_A5_reg        ; 02
    btfsc        in0,6
	comf		 A2_A5_reg,f

	clrf		 A5_A2_reg        ; 03
    btfsc        in0,5
	comf		 A5_A2_reg,f

	clrf		 A4_A5_reg        ; 04
    btfsc        in0,4
	comf		 A4_A5_reg,f

	clrf		 A5_A4_reg        ; 05
    btfsc        in0,3
	comf		 A5_A4_reg,f

	clrf	 	 A1_A5_reg        ; 06
    btfsc        in0,2
	comf	 	 A1_A5_reg,f

	clrf		 A5_A1_reg        ; 07
    btfsc        in0,1
	comf		 A5_A1_reg,f

	clrf		 A2_A0_reg        ; 08
    btfsc        in0,0
	comf		 A2_A0_reg,f
 
	clrf	 	 A0_A2_reg        ; 09
    btfsc        in1,7
    comf         A0_A2_reg,f

	clrf		 A4_A0_reg        ; 10
    btfsc        in1,6
	comf		 A4_A0_reg,f

	clrf		 A0_A4_reg        ; 11
    btfsc        in1,5
	comf		 A0_A4_reg,f
 
	clrf	 	 A1_A0_reg        ; 12
    btfsc        in1,4
	comf	 	 A1_A0_reg,f

	clrf		 A0_A1_reg        ; 13
    btfsc        in1,3
    comf         A0_A1_reg,f

	clrf		 A4_A2_reg        ; 14
    btfsc        in1,2
	comf		 A4_A2_reg,f

	clrf	 	 A2_A4_reg        ; 15
    btfsc        in1,1
	comf	 	 A2_A4_reg,f

	clrf		 A1_A2_reg        ; 16
    btfsc        in1,0
	comf		 A1_A2_reg,f

	clrf		 A2_A1_reg        ; 17
    btfsc        in2,7
	comf		 A2_A1_reg,f

	clrf		 A1_A4_reg        ; 18
    btfsc        in2,6
	comf		 A1_A4_reg,f
 
	clrf		 A4_A1_reg        ; 19
    btfsc        in2,5
	comf		 A4_A1_reg,f


    movf         speed,w
    call         strobe_delay

    return
#endif

#ifdef DISPLAY_1BIT_F
;**********************************************************************
display_1bit ; 20 LEDs 3x3
;**********************************************************************

    movwf        speed              ;w has the speed/delay

	clrf		 A4_A0_reg        ; 1G
    btfsc        in0,7
	comf		 A4_A0_reg,f

	clrf		 A5_A0_reg        ; 2G
    btfsc        in0,5
	comf		 A5_A0_reg,f

	clrf		 A5_A1_reg        ; 3G
    btfsc        in0,3
	comf		 A5_A1_reg,f

	clrf		 A2_A0_reg        ; 4G
    btfsc        in0,1
	comf		 A2_A0_reg,f

	clrf		 A4_A2_reg        ; 5G
    btfsc        in1,7
	comf		 A4_A2_reg,f

	clrf		 A5_A2_reg        ; 6G
    btfsc        in1,5
	comf		 A5_A2_reg,f

	clrf	 	 A1_A0_reg        ; 7G
    btfsc        in1,3
	comf	 	 A1_A0_reg,f

	clrf		 A4_A1_reg        ; 8G
    btfsc        in1,1
	comf		 A4_A1_reg,f

	clrf		 A5_A4_reg        ; 9G
    btfsc        in2,7
	comf		 A5_A4_reg,f

#ifdef MONO
	clrf		 A0_A4_reg        ; 1R
	clrf		 A0_A5_reg        ; 2R
	clrf	 	 A1_A5_reg        ; 3R
	clrf	 	 A0_A2_reg        ; 4R
	clrf	 	 A2_A4_reg        ; 5R
	clrf		 A2_A5_reg        ; 6R
	clrf		 A0_A1_reg        ; 7R
	clrf		 A1_A4_reg        ; 8R
	clrf		 A4_A5_reg        ; 9R

#else

	clrf		 A0_A4_reg        ; 1R
    btfsc        in0,6
	comf		 A0_A4_reg,f

	clrf		 A0_A5_reg        ; 2R
    btfsc        in0,4
	comf		 A0_A5_reg,f

	clrf	 	 A1_A5_reg        ; 3R
    btfsc        in0,2
	comf	 	 A1_A5_reg,f
 
	clrf	 	 A0_A2_reg        ; 4R
    btfsc        in0,0
    comf         A0_A2_reg,f

	clrf	 	 A2_A4_reg        ; 5R
    btfsc        in1,6
	comf	 	 A2_A4_reg,f

	clrf		 A2_A5_reg        ; 6R
    btfsc        in1,4
	comf		 A2_A5_reg,f

	clrf		 A0_A1_reg        ; 7R
    btfsc        in1,2
    comf         A0_A1_reg,f

	clrf		 A1_A4_reg        ; 8R
    btfsc        in1,0
	comf		 A1_A4_reg,f
 
	clrf		 A4_A5_reg        ; 9R
    btfsc        in2,6
	comf		 A4_A5_reg,f
#endif

	clrf		 A1_A2_reg        ; 16 IR
	clrf		 A2_A1_reg        ; 17 IR



    movf         speed,w
    call         strobe_delay

    return
#endif

#ifdef DISPLAY_1BIT_G
;**********************************************************************
display_1bit ; 256 Led 16x8x2 matrix
;**********************************************************************

    movwf        speed              ;w has the speed/delay
;
; going to break good coding rulTMR2es for compact code, reorder or move
; the Led_xxx vars and you break the code!
;


; process page 1 (0x20) Led_Gxx vars
    movlw        (Led_G00 & 0xff)
    movwf        FSR
    bcf          STATUS,7

    movfw        in0
    call         d2b_8bits
    movfw        in1
    call         d2b_8bits
    movfw        in2
    call         d2b_8bits
    movfw        in3
    call         d2b_8bits

; process page 2 (0x60) Led_Gxx vars
    movlw        (Led_G40 & 0xff)
    movwf        FSR
    bsf          STATUS,7

    movfw        in4
    call         d2b_8bits
    movfw        in5
    call         d2b_8bits
    movfw        in6
    call         d2b_8bits
    movfw        in7
    call         d2b_8bits
    movfw        in8
    call         d2b_8bits
    movfw        in9
    call         d2b_8bits
    movfw        ina
    call         d2b_8bits
    movfw        inb
    call         d2b_8bits
    movfw        inc
    call         d2b_8bits
    movfw        ind
    call         d2b_8bits
    movfw        ine
    call         d2b_8bits
    movfw        inf
    call         d2b_8bits

; process page 1 (0x20) Led_Rxx vars
    movlw        (Led_R00 & 0xff)
    movwf        FSR
    bcf          STATUS,7

    movfw        in10
    call         d2b_8bits
    movfw        in11
    call         d2b_8bits
    movfw        in12
    call         d2b_8bits
    movfw        in13
    call         d2b_8bits



; process page 3 (0x60) Led_Rxx vars
    movlw        (Led_R40 & 0xff)
    movwf        FSR
    bsf          STATUS,7

    movfw        in14
    call         d2b_8bits
    movfw        in15
    call         d2b_8bits
    movfw        in16
    call         d2b_8bits
    movfw        in17
    call         d2b_8bits
    movfw        in18
    call         d2b_8bits
    movfw        in19
    call         d2b_8bits
    movfw        in1a
    call         d2b_8bits
    movfw        in1b
    call         d2b_8bits
    movfw        in1c
    call         d2b_8bits
    movfw        in1d
    call         d2b_8bits
    movfw        in1e
    call         d2b_8bits
    movfw        in1f
    call         d2b_8bits


    movf         speed,w
    call         strobe_delay

    bcf          STATUS,7
    return

;**********************************************************************
d2b_8bits
;**********************************************************************

    movwf        fcount1

    clrf         INDF
    btfsc        fcount1,7
    comf         INDF,f

    incf         FSR,f
    clrf         INDF
    btfsc        fcount1,6
    comf         INDF,f

    incf         FSR,f
    clrf         INDF
    btfsc        fcount1,5
    comf         INDF,f

    incf         FSR,f
    clrf         INDF
    btfsc        fcount1,4
    comf         INDF,f

    incf         FSR,f
    clrf         INDF
    btfsc        fcount1,3
    comf         INDF,f

    incf         FSR,f
    clrf         INDF
    btfsc        fcount1,2
    comf         INDF,f

    incf         FSR,f
    clrf         INDF
    btfsc        fcount1,1
    comf         INDF,f

    incf         FSR,f
    clrf         INDF
    btfsc        fcount1,0
    comf         INDF,f

    incf         FSR,f
    return

#endif

#ifdef DISPLAY_1BIT_H
#include display_1bit_h.asm
#endif

#ifdef DISPLAY_2BIT_A
;**********************************************************************
display_2bit
;**********************************************************************
    movf    speed,w             ;enter here if repeat count is in speed
display_w_2bit                      ;enter here if repeat count is in W reg

; 76543210 <-- bits
; AABBCCDD <-- LEDs
; 01010101 <-- stays on for 1 unit  - b'01'
; 10101010 <-- stays on for 2 units - b'10'
; 11111111 <-- stays on for 3 units - b'11'

; in0 LEDs 1,2,3,4
; in1 LEDs 5,6,C


	clrf		 Ar_reg
    movlw        BRIGHT1
    btfsc        in0,6
    addwf        Ar_reg,f
    movlw        BRIGHT2
    btfsc        in0,7
    addwf        Ar_reg,f
 
	clrf	 	 Ag_reg
    movlw        BRIGHT1
    btfsc        in0,2
    addwf        Ag_reg,f
    movlw        BRIGHT2
    btfsc        in0,3
    addwf        Ag_reg,f

	clrf		 Ab_reg
    movlw        BRIGHT1
    btfsc        in1,6
    addwf        Ab_reg,f
    movlw        BRIGHT2
    btfsc        in1,7
    addwf        Ab_reg,f

	clrf		 Cr_reg
    movlw        BRIGHT1
    btfsc        in0,4
    addwf        Cr_reg,f
    movlw        BRIGHT2
    btfsc        in0,5
    addwf        Cr_reg,f
 
	clrf	 	 Cg_reg
    movlw        BRIGHT1
    btfsc        in0,0
    addwf        Cg_reg,f
    movlw        BRIGHT2
    btfsc        in0,1
    addwf        Cg_reg,f

	clrf		 Cb_reg
    movlw        BRIGHT1
    btfsc        in1,4
    addwf        Cb_reg,f
    movlw        BRIGHT2
    btfsc        in1,5
    addwf        Cb_reg,f 

#ifdef BADGE
	clrf		 Center_reg
    movlw        BRIGHT1
    btfsc        in1,2
    addwf        Center_reg,f
    movlw        BRIGHT2
    btfsc        in1,3
    addwf        Center_reg,f 
#endif

    movf         speed,w
    call         strobe_delay
    movf         speed,w
    call         strobe_delay
    movf         speed,w
    call         strobe_delay

    return
#endif

#ifdef DISPLAY_2BIT_C
;**********************************************************************
display_2bit
;**********************************************************************
    movf    speed,w             ;enter here if repeat count is in speed
display_w_2bit                      ;enter here if repeat count is in W reg

; 76543210 <-- bits
; AABBCCDD <-- LEDs
; 01010101 <-- stays on for 1 unit  - b'01'
; 10101010 <-- stays on for 2 units - b'10'
; 11111111 <-- stays on for 3 units - b'11'

; in0 red
; in1 green
; in2 blue

	clrf		 Ar_reg
    movlw        BRIGHT1
    btfsc        in0,6
    addwf        Ar_reg,f
    movlw        BRIGHT2
    btfsc        in0,7
    addwf        Ar_reg,f
 
	clrf	 	 Ag_reg
    movlw        BRIGHT1
    btfsc        in1,6
    addwf        Ag_reg,f
    movlw        BRIGHT2
    btfsc        in1,7
    addwf        Ag_reg,f

	clrf		 Ab_reg
    movlw        BRIGHT1
    btfsc        in2,6
    addwf        Ab_reg,f
    movlw        BRIGHT2
    btfsc        in2,7
    addwf        Ab_reg,f

	clrf		 Br_reg
    movlw        BRIGHT1
    btfsc        in0,4
    addwf        Br_reg,f
    movlw        BRIGHT2
    btfsc        in0,5
    addwf        Br_reg,f
 
	clrf	 	 Bg_reg
    movlw        BRIGHT1
    btfsc        in1,4
    addwf        Bg_reg,f
    movlw        BRIGHT2
    btfsc        in1,5
    addwf        Bg_reg,f

	clrf		 Bb_reg
    movlw        BRIGHT1
    btfsc        in2,4
    addwf        Bb_reg,f
    movlw        BRIGHT2
    btfsc        in2,5
    addwf        Bb_reg,f 

	clrf		 Cr_reg
    movlw        BRIGHT1
    btfsc        in0,2
    addwf        Cr_reg,f
    movlw        BRIGHT2
    btfsc        in0,3
    addwf        Cr_reg,f
 
	clrf	 	 Cg_reg
    movlw        BRIGHT1
    btfsc        in1,2
    addwf        Cg_reg,f
    movlw        BRIGHT2
    btfsc        in1,3
    addwf        Cg_reg,f

	clrf		 Cb_reg
    movlw        BRIGHT1
    btfsc        in2,2
    addwf        Cb_reg,f
    movlw        BRIGHT2
    btfsc        in2,3
    addwf        Cb_reg,f 

	clrf		 Dr_reg
    movlw        BRIGHT1
    btfsc        in0,0
    addwf        Dr_reg,f
    movlw        BRIGHT2
    btfsc        in0,1
    addwf        Dr_reg,f
 
	clrf	 	 Dg_reg
    movlw        BRIGHT1
    btfsc        in1,0
    addwf        Dg_reg,f
    movlw        BRIGHT2
    btfsc        in1,1
    addwf        Dg_reg,f

	clrf		 Db_reg
    movlw        BRIGHT1
    btfsc        in2,0
    addwf        Db_reg,f
    movlw        BRIGHT2
    btfsc        in2,1
    addwf        Db_reg,f 

#ifdef BADGE
	clrf		 Center_reg
    movlw        BRIGHT1
    btfsc        in3,6
    addwf        Center_reg,f
    movlw        BRIGHT2
    btfsc        in3,7
    addwf        Center_reg,f 
#endif

    movf         speed,w
    call         strobe_delay
    movf         speed,w
    call         strobe_delay
    movf         speed,w
    call         strobe_delay

    return
#endif

#define BRIGHT1H 0xA0
#define BRIGHT2H 0x40

#ifdef DISPLAY_2BIT_D
#include display_2bit_d
#endif

#ifdef DISPLAY_2BIT_E
#include display_2bit_e
#endif

#ifdef DISPLAY_1BIT_E
;**********************************************************************
display_1bit ; RGB Stick (14 * 3 = 42 LEDs
;**********************************************************************
    var temp4

    movwf        speed              ;w has the speed/delay

; set all var 0xA0 to 0xEF to zero
    movlw        0xA0              
    movwf        FSR

    movlw        0x50
    movwf        temp4

clr_loop

    clrf         INDF
    incf         FSR,f
    decfsz       temp4,f
    goto         clr_loop

    pageselw rgb_stick_expand
    call         rgb_stick_expand
    pageselw display_1bit

    movf         speed,w
    call         strobe_delay

    return
#endif

;**********************************************************************
;   IR Tester
;**********************************************************************
IR_Tester
itop
    movlw        0x02
    subwf        instate,w
    btfss        STATUS,C
    clrw
    movwf        in0
    
    movlw        0x00
    movwf        in1

    movlw        0x01
    call         display_1bit       

;
;   Check for push button
;
ibutton
    movf        button,w
    btfsc       STATUS,Z
    goto        iloop1
    clrf        max_instate
    clrf        instate

    movf        scount,w                    ; if sending an IR command ignore button
    addlw       0                           ; not sure if needed
    btfss       STATUS,Z                   
    goto        ibutton    

    movf        button,w                    ; 2st 8 bits are the buttons
    movwf       in1
    clrf        in0                         ; next 8 are zero
;    movlw       0x80
;    movwf       in2                         ; led 17 is on

#ifdef M8X16
    movfw       button
    movwf       in3
#endif

    movlw       0x01
    call        display_1bit

;   send an IR signel
    clrf        out_address                 ; address 0x00 "TV remote"

#ifdef M3X3

    movlw        0x03              ; if button 3 & 4 presses
    subwf        button,w
    btfsc        STATUS,Z
    goto         mode_loop

    btfsc        button,0    ; if button 3 pressed 
    goto         send_chan_up

    btfsc        button,1    ; if button 4 pressed 
    goto         send_chan_down

    btfsc        button,2    ; if button 1 pressed 
    goto         send_vol_up

    btfsc        button,3    ; if button 2 pressed 
    goto         send_vol_down

    btfsc        button,4    ; if button 5 pressed 
    goto         send_on_off

send_chan_up
    movlw       0x20
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

send_chan_down
    movlw       0x21
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

send_vol_up
    movlw       0x10
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

send_vol_down
    movlw       0x11
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

#endif

send_on_off
    movlw       0x0c
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton


;
;   Check for IR Command
;
iloop1
    btfss       IR_in_good,0
    goto        itop
    clrf        IR_in_good

;  flash all LEDs Red
    movlw       0xF0
    movwf       in0
    clrf        in1

    movlw       0x7f
    call        display_1bit    

;   flash all LEDs off
    clrf        in0
    clrf        in1

    movlw       0x3f
    call        display_1bit

;   flash all LEDs Red
    movlw       0xF0
    movwf       in0
    clrf        in1

    movlw       0x7f
    call        display_1bit

;   display command and address
    movf        command,w
    movwf       in0
    movf        address,w
    movwf       in1

    movlw       0xff
    call        display_1bit
    movlw       0xff
    call        display_1bit
    clrf        max_instate
    clrf        instate

    goto        itop

#ifdef M3X3
;**********************************************************************
Dice
;**********************************************************************
    var          temp

    call         roll_dice
dice_loop

    movlw        0x03              ; if button 3 & 4 presses
    subwf        button,w
    btfsc        STATUS,Z
    goto         mode_loop

    btfsc        button,0           ; if button 1 pressed 
    call         roll_dice

    movlw        0x01       
    subwf        temp,w
    btfsc        STATUS,Z
    goto         diplay_1

    movlw        0x02       
    subwf        temp,w
    btfsc        STATUS,Z
    goto         diplay_2

    movlw        0x03       
    subwf        temp,w
    btfsc        STATUS,Z
    goto         diplay_3

    movlw        0x04       
    subwf        temp,w
    btfsc        STATUS,Z
    goto         diplay_4

    movlw        0x05       
    subwf        temp,w
    btfsc        STATUS,Z
    goto         diplay_5

    movlw        0x06       
    subwf        temp,w
    btfsc        STATUS,Z
    goto         diplay_6

;   get random number 0-7 re-roll if we get a 0 or 7.
    call         roll_dice
    goto         dice_loop


diplay_1
    clrf         in0
    movlw        b'11000000'
    movwf        in1
    clrf         in2
    goto         dice_display_digit

diplay_2
    movlw        b'00001100'
    movwf        in0
    movwf        in1
    clrf         in2
    goto         dice_display_digit

diplay_3
    movlw        b'00001100'
    movwf        in0
    movlw        b'11001100'
    movwf        in1
    clrf        in2
    goto         dice_display_digit

diplay_4
    movlw        b'11001100'
    movwf        in0
    movwf        in2
    movlw        b'00001100'
    movwf        in1
    goto         dice_display_digit

diplay_5
    movlw        b'11001100'
    movwf        in0
    movwf        in1
    movwf        in1
    goto         dice_display_digit

diplay_6
    movlw        b'11001111'
    movwf        in0
    movwf        in2
    movlw        b'00111100'
    movwf        in1

dice_display_digit
    movlw   0xff
    call    display_1bit

    goto    dice_loop


roll_dice
    incf         temp2,f
    call         gen_random
    movlw        b'01010101'
    movwf        in0
    movwf        in1
    movwf        in2

    movlw   0xff
    call    display_1bit

    movlw        b'10101010'
    movwf        in0
    movwf        in1
    movwf        in2

    movlw   0xff
    call    display_1bit

    btfsc        button,0           ; if button 1 pressed 
    goto         roll_dice

    movfw        random
    addwf        count1,w
    addwf        temp2,w
    movwf        temp
    rrf          temp,f
    movlw        0x07
    andwf        temp,f

    return

#endif

;
; M A I N
;
;**********************************************************************
main
;**********************************************************************
    clrf        PORTA
    clrf        TMR0 
    clrf        pattern
;    movlw       0x05
;    movwf       pattern
    clrf        scount
    clrf        toggle
    clrf        address
    clrf        command
    clrf        IR_lhalf
    clrf        instate
    clrf        max_instate
    clrf        IR_in_good
    clrf        dcycle
    clrf        count1
    clrf        count2
    clrf        button
#ifdef PATTERN2
    clrf         delay1
    clrf         fad
    clrf         color
#end
#idndef C12
#ifndef C19
#ifndef M3X3
#ifdef MONO
	clrf Br_reg
	clrf Bg_reg
	clrf Bb_reg
	clrf Dr_reg
	clrf Dg_reg
	clrf Db_reg
#endif
#endif
#endif
#endif

   BANKSEL OSCCON
#ifdef __16F886
    movlw   b'01110001'     ;switch to 8 MHz clock
#else
    movlw   b'01110000'     ;switch to 8 MHz clock
#endif
    iorwf   OSCCON,f

#ifdef __16F886
    BANKSEL ANSEL
    clrf    ANSEL           ;set pins to digital
    clrf    ANSELH           ;set pins to digital
#else
    BANKSEL ANSEL 
    clrf    ANSEL           ;set pins to digital
#endif


   BANKSEL OPTION_REG

; set up TMR0 & pullups
;             +---------- disable pullups (1)
;             |+--------- interrupt edge select (don't care)
;             ||+-------- TMR0 source = internal clock (0)
;             |||+------- TMR0 source edge select (don't care)
;             ||||+------ assign prescaler to TMR0 (0)
;             |||||+++--- prescaler set to 8X (010)
;             |||||||| 
    movlw   b'10000010'
    movwf   OPTION_REG

#ifdef C19
;   enable pullups on portA
    bcf         OPTION_REG,NOT_RAPU

;   input on A5
    clrf         WPUA       ; disable all pullups
    bsf          WPUA,5     ; enable pullup A5
#endif

#ifdef SRGB
;   enable pullups on portA
    bcf         OPTION_REG,NOT_RAPU

;   input on A5
    clrf         WPUA       ; disable all pullups
    bsf          WPUA,5     ; enable pullup A5
    bsf          WPUA,4     ; enable pullup A4
#endif

#ifdef C12 
;   BANKSEL OPTION_REG
;   bsf     OPTION_REG, NOT_RBPU
;
;  input C7,C5 buttons
;  input C6 IR.
   BANKSEL TRISC
    movlw   b'11100000'
    movwf   TRISC   ; C7,C6,C5 input
#endif

#ifdef M8X16
;  E1 - IR/Button
;  C2 - Button2
;  C1 - IR out
;  C3/C4 - I2C
;  C0,C5,C6,C7 - strobe select output
   BANKSEL TRISC
    movlw   b'00011100'
    movwf   TRISC   ; C7,C6,C5,C1,C0 output
    clrf    TRISA   ; all A output
    clrf    TRISB   ; all B output
    movlw   b'00001000'
    movwf   TRISE   ; E3 input
#endif


    BANKSEL     button 
    clrf        button

#ifdef RANDOM
    movlw       0x1D
    movwf       random
#endif

;   enable timer0 interupt
    bsf     INTCON,T0IE
    bsf     INTCON,GIE

loop_ddf


;  flash all LEDs on     This kills some time, allowing us to sample the button and IR-Rx
#ifdef M8X16
    movlw   in0
    movwf   FSR
    movlw   0x20
    movwf   fcount1

    movlw   0xFF
loop_set_on
    movwf   INDF
    incf    FSR,f
    decfsz  fcount1,f
    goto    loop_set_on
#else
    movlw   b'11111111'

    movwf   in0
    movwf   in1
    movwf   in2
#ifdef C19
    movwf   in3
    movwf   in4
#endif
#ifdef SRGB
    movwf   in3
    movwf   in4
    movwf   in5
#endif
#endif

#ifdef C12a                 ; going to flash the config1 value!
    movfw   config1
    movwf   fcount1        ; flash 1 - mono single, 2 - mono dual  3 - bi single or 4 - bi dual
    incf    fcount1,f

flash_loop
    movlw   b'10101010'
    movwf   in0
    movwf   in1
    movwf   in2
    movwf   in3
    movwf   in4

    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit

    movlw   b'01010101'
    movwf   in0
    movwf   in1
    movwf   in2
    movwf   in3
    movwf   in4

    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit

    decfsz  fcount1,f
    goto    flash_loop

    movlw   b'11111111'
    movwf   in0
    movwf   in1
    movwf   in2
    movwf   in3
    movwf   in4

#endif

    movlw   0xff            ; allways flash once
    call    display_1bit
    movlw   0xff
    call    display_1bit

#ifdef M3X3                 ; have to wait for the IR to go high, and the buttons to de-bounce on 3x3 powerup
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit
#endif


; Trun all the LEDs off
#ifdef M8X16
    movlw   in0
    movwf   FSR
    movlw   0x20
    movwf   fcount1

    movlw   0x00
loop_set_off
    movwf   INDF
    incf    FSR,f
    decfsz  fcount1,f
    goto    loop_set_off
#else
    clrf   in0
    clrf   in1
    clrf   in2
#ifdef C19
    clrf   in3
    clrf   in4
#endif
#ifdef SRGB
    clrf   in3
    clrf   in4
    clrf   in5
#endif
#endif
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit

    call read_demo_mode

    movfw   button
    movwf   in1
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit


#ifndef M3X3 
;   if button pressed durring powerup run IR_Tester
;   else run pattern driver
;
    btfss       button,0          
    goto        pattern_driver
    call        toggle_demo
#ifdef ENABLE_IR
    goto        IR_Tester
#else
    goto        pattern_driver
#endif
#else
;
; 3X3 mode selection logic
;
    var mode
#define MAX_MODE 3
	clrf         mode

    movfw        button      ; if no button go to pattern mode.
    btfsc        STATUS,Z
    goto         pattern_driver

mode_loop

;
;   Dsiplay the Mode in LEDs 7,8 and 9
;
    clrf         in0
    incf         mode,w
    movwf        b2l_in_green
    clrf         b2l_in_red
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in1
    movf         b2l_out_low,w
    movwf        in2
    rrf          in1,f
    rrf          in2,f
    rrf          in1,f
    rrf          in2,f
    rrf          in1,f
    rrf          in2,f
    rrf          in1,f
    rrf          in2,f

    movlw   0xff
    call    display_1bit

    movlw   0xff
    call    display_1bit

    btfsc        button,0    ; if button 1 pressed inc pattern
    call         next_mode

    btfsc        button,1    ; if button 2 pressed dec pattern
    call         past_mode
;
;   missing bound check on up/down of pattern.
;
    btfsc        button,4    ; if button 5 try to exit
    goto         mode_loop2

    goto    mode_loop

mode_loop2

    movlw        0x00              ; mode=0
    subwf        mode,w
    btfsc        STATUS,Z
    goto         pattern_driver

    movlw        0x01              ; mode=1
    subwf        mode,w
    btfsc        STATUS,Z
    goto         IR_Tester


    movlw        0x02              ; mode=2
    subwf        mode,w
    btfsc        STATUS,Z
    goto         Dice

;    movlw        0x02              ; mode=3
;    subwf        mode,w
;    btfsc        STATUS,Z
;    goto         TicTacToe

     goto         mode_loop

;**********************************************************************
next_mode
;**********************************************************************
    incf         mode,f
    movf         mode,w
    sublw        MAX_MODE  ; max pattern?
    btfsc        STATUS,2   ; z bit check
    clrf         mode    ; reset to zero
    return

;**********************************************************************
past_mode
;**********************************************************************
    decf         mode,f
    movf         mode,w
    addlw        1  ; max pattern?
    btfss        STATUS,2   ; z bit check
    goto         mode_past_exit
    movlw        MAX_MODE-1
    movwf        mode
mode_past_exit
    return


#endif

;**********************************************************************
table_lookup
;**********************************************************************
    movf         tbl_hi,w
    movwf        PCLATH
    movf         pindex,w
    addwf        tbl_low,w
    btfsc        STATUS,0     ; check carry flag
    incf         PCLATH,f
    movwf        PCL

;**********************************************************************
jump_address
;**********************************************************************
; Portability : clean
;
    var offset_hi
    var offset_low

    movf         PCLATH,w
    movwf        pclath_save
    movf         offset_hi,w
    movwf        PCLATH

    movf         offset_low, w
    movwf        PCL


;**********************************************************************
MasterTable
;**********************************************************************
    make_mtab NUM_TAB


#ifdef PATTERN16
#define BRIGHT1_lo 0x04
#define BRIGHT2_lo 0x0A
#define BRIGHT1_hi 0x40
#define BRIGHT2_hi 0xA0

;**********************************************************************
table_type_16
;**********************************************************************
;
;  1 bytes
;
;  ABBCCCCC
;
;  A = shire Right/Left
;  BB = two bit intensity to shift on
;  CCCCC = Number of shifts to loop
;
;  if CCCCC = 0x11111, specical case: turn all LEDs off.

    var t7count
    var t17_loop

    pageselw get_next_pattern_entry
    call         get_next_pattern_entry
    movwf        in0

    call         get_next_pattern_entry
    movwf        in1
    pageselw table_type_16

    movlw        b'00011111'
    andwf        in0,w
    movwf        t7count

    movlw        b'00011111'  ; if shiftcount is 31, then clear all LEDs
    subwf        t7count,w
    btfss        STATUS,Z
    goto         t7_loop_red
    
    clrf         in0           ; quick way to clear all the LEDS.
    clrf         in1
    clrf         in2
    clrf         in3
    clrf         in4
    clrf         in5
    pageselw display_1bit
    call         display_1bit
    pageselw table_type_16
    goto         t7_return

t7_loop_red
    btfsc        in0,7
    goto         t7_set19_red

    call red_up
    goto         t7_loop_green

t7_set19_red

    call red_down

t7_loop_green
    btfsc        in0,6
    goto         t7_set19_green

    call green_up

    goto         t7_loop_blue
;
;   set LED 19
t7_set19_green

    call green_down

t7_loop_blue

    btfsc        in0,5
    goto         t7_set19_blue

    call blue_up

    goto         t7_cont
;
;   set LED 19
t7_set19_blue
    call  blue_dowm
t7_cont
    pageselw strobe_delay
    movf         pspeed,w
    call         strobe_delay
    pageselw t7_cont
;
;   This is a quick hack, because without this button presses are not seen for minutes
;   This early exit might impact the pattern getting displayed.
;
    btfsc        button,0    ; if putton pressed show pattern id
    goto         t7_return

    btfsc        IR_in_good,0
    goto         t7_return

    decfsz       t7count,f
    goto         t7_loop_red

t7_return
    return

;**********************************************************************
red_up
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        A2_C1_reg   ; index = 13 R
    movwf        FSR

red_up_loop
    movfw        INDF        ; load R [index]
    incf         FSR,f         ; index ++
    movwf        INDF        ; store R [index]

    decf         FSR,f         ; index - 2
    decf         FSR,f

    decfsz       t17_loop,f
    goto         red_up_loop
;
;   01 Red
;
    incf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,6
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,7
    addwf        INDF,f     ;01

    return

;**********************************************************************
red_down
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C2_C3_reg   ; index = 02 R
    movwf        FSR

red_down_loop
    movfw        INDF        ; load R [index]
    decf         FSR,f         ; index - 1
    movwf        INDF        ; store R [index]

    incf         FSR,f         ; index + 2
    incf         FSR,f

    decfsz       t17_loop,f
    goto         red_down_loop
;
;   14 Red
;
    decf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,6
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,7
    addwf        INDF,f     ;01

    return

;**********************************************************************
green_up
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C4_C1_reg   ; index = 13 G
    movwf        FSR

green_up_loop
    movfw        INDF        ; load G [index]
    incf         FSR,f         ; index ++
    movwf        INDF        ; store G [index]

    decf         FSR,f         ; index - 2
    decf         FSR,f

    decfsz       t17_loop,f
    goto         green_up_loop
;
;   01 Green
;
    incf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,4
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,5
    addwf        INDF,f     ;01

    return

;**********************************************************************
green_down
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C0_C3_reg   ; index = 02 Green
    movwf        FSR

green_down_loop
    movfw        INDF        ; load R [index]
    decf         FSR,f         ; index - 1
    movwf        INDF        ; store R [index]

    incf         FSR,f         ; index + 2
    incf         FSR,f

    decfsz       t17_loop,f
    goto         green_down_loop
;
;   14 Green
;
    decf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,4
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,5
    addwf        INDF,f     ;01

    return


;**********************************************************************
blue_up
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C2_C1_reg   ; index = 13 G
    movwf        FSR

blue_up_loop
    movfw        INDF        ; load G [index]
    incf         FSR,f         ; index ++
    movwf        INDF        ; store G [index]

    decf         FSR,f         ; index - 2
    decf         FSR,f

    decfsz       t17_loop,f
    goto         blue_up_loop
;
;   01 blue
;
    incf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,2
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,3
    addwf        INDF,f     ;01

    return


;**********************************************************************
blue_dowm
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C4_C3_reg   ; index = 02 Blue
    movwf        FSR

blue_down_loop
    movfw        INDF        ; load R [index]
    decf         FSR,f         ; index - 1
    movwf        INDF        ; store R [index]

    incf         FSR,f         ; index + 2
    incf         FSR,f

    decfsz       t17_loop,f
    goto         blue_down_loop
;
;   14 Green
;
    decf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,2
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,3
    addwf        INDF,f     ;01

    return
#endif

;
; These are down here for memory placement
;

#ifdef DISPLAY_1BIT_E
#include display_1bit_e_part2
#endif

#ifdef PATTERN17
#include pattern_17_part2.asm
#endif

#ifdef PATTERN18
#include pattern_18.asm  
#endif

#ifdef PATTERN20
#include pattern_20.asm
#endif

#ifdef PATTERN21
#include pattern_21.asm
#endif

#ifdef C12
    ORG     0x800
#endif

#ifdef PATTERN27
#include "pattern_27.asm"
#endif

;
; These are the pattern tables
;


#ifdef RGB4
#include <patterns_4rgb.asm>
#endif

#ifdef SRGB
#include <patterns_stick_rgb.asm>
#endif

#ifdef BI6
#ifdef MONO
#ifdef BADGE
#include <patterns_6led+c.asm>
#else
#include <patterns_6led.asm>
#endif
#else
#ifdef BADGE
#include <patterns_6bi+c.asm>
#else
#include <patterns_6bi.asm>
#endif
#endif
#endif

#ifdef M3X3
#include <patterns_3x3.asm>
#endif

#ifdef S19
#include <patterns_19led_stick.asm>
#endif

#ifdef C19
#ifdef MONO
#include <patterns_19mono_circle.asm>
#else
#include <patterns_19bi_circle.asm>
#endif
#endif

#ifdef M8X16
#include <patterns_8x16.asm>
#endif

#ifdef C12
#include <patterns_dual_12circle.asm>
#endif



    END             ; directive 'end of program'
